DECLARE FUNCTION zr$ (wert AS INTEGER)
DECLARE SUB FillDatesBetweenToFile (datum1$, datum2$, fout%)
DECLARE SUB GetPwd ()
DECLARE SUB DeleteSaleDestItem (verkaufspunkt$)
DECLARE SUB BuchungenHeute ()
DECLARE SUB Graph (a!, B!, c!, d!, file$, fr!)
DECLARE SUB MakeTotallyList (status%)
DECLARE FUNCTION GetDebitor$ (namen$, wert$)

'<<< OSCODE 5 OPTIMIERT >>>

'starcraft Moneycab programmed by Urs Langmeier, 12.2.2002 - 16.3.2002

'LaOS Version 2.00 - 4.00 Copyright (C) Urs Langmeier, New BCO
'Sommer 1998, Version ohne ScreenText und ohne Run-on-command

'Entwickelt unter QBASIC von Urs Langmeier
'Idee & Programmierung: Urs Langmeier

'Alle Urheber- und Leistungsschutzrechte vorbehalten. Der Code darf nicht un-
'erlaubt kopiert oder verkauft werden.

TYPE Debitortype
    Adresse AS STRING * 500
    status AS INTEGER
    mahnung1 AS STRING * 10
    mahnung2 AS STRING * 10
    mahnung3 AS STRING * 10
    betreibung AS STRING * 10
    Konto AS STRING * 12
END TYPE
'Status:
'0 ungemahnt
'1 1. Mahnung eingeleitet
'2 2. Mahnung eingeleitet
'3 3. Mahnung eingeleitet
'4 Betreibung eingeleitet
'5 Bezahlt
DECLARE SUB ClearBox (Zeilen!, Spalten!, Caption$)
DECLARE SUB CreateDetail (Detailname$, Buchungstext$, start%)
DECLARE SUB BesonderesList ()
DECLARE FUNCTION GetValidPassword% (checksum!, password$)
DECLARE FUNCTION PasswordOk% ()
DECLARE SUB SuchListe (namen$)
DECLARE FUNCTION FU$ (a$, x!)
DECLARE SUB Jahresabschluss ()
DECLARE SUB Optionen ()
DECLARE FUNCTION SDate$ (Datum$)
DECLARE SUB Monatsabschluss (fragen%)
DECLARE SUB ManuelleBuchungen ()
DECLARE SUB ProdukteLager ()
DECLARE SUB PieSliece (a%, B%, Radius!, StartPz, EndePz, Titel$, col%, randcol%)
DECLARE FUNCTION CoSinus! (Winkel!)
DECLARE FUNCTION Sinus! (Winkel!)
DECLARE SUB Statistiken ()
CONST PI = 3.141592654#
DECLARE SUB ProgressBar (Stat AS INTEGER)
DECLARE SUB FileCopy (Source$, Dest$, capt$)
DECLARE SUB TransaktionsStorno ()
DECLARE FUNCTION positiv! (wert!)
DECLARE FUNCTION GetLager! (Produkt$)
DECLARE SUB GetOKParity (Bezeichnung$, wert$, lager$)
DECLARE SUB FormatToWaehrung (w$)
TYPE Produktedatenbank
        Produkt AS STRING * 12
        lager AS INTEGER 'neu: max. Lagerbestand
        Beschreibung AS STRING * 200
        VP AS STRING * 10 'neu: EP
        EP AS STRING * 10 'neu: VP
END TYPE
DECLARE FUNCTION Produktwert$ (wert!)
DECLARE FUNCTION Franken$ (wert!)
DECLARE SUB ListeKontobuch ()
DECLARE SUB TransaktionErfassen ()
DECLARE SUB SetTexts (start%, Txt$, weiter%)

DECLARE FUNCTION ComboBox$ (Nr!, z!, s!, zu!, su!)
DECLARE FUNCTION Format$ (FormatString AS STRING)
DECLARE SUB PartFormat (Text$, Setting$)
DECLARE SUB Echo (Txt$)
DECLARE FUNCTION MenuInt$ (Item$, Trennzeichen$)
DECLARE SUB SetAttr (aDatei$, Attr$)
DECLARE FUNCTION LaOSFileName$ (DosFile$)
DECLARE FUNCTION ende! (Nr!)
DECLARE SUB Loesche (AlterName$)
DECLARE SUB MenuBox (Zeilen!, Spalten!, Caption$)
DECLARE SUB EditBox (z!, s!, zu!, su!)
DECLARE FUNCTION LinkIt$ ()
DECLARE FUNCTION DriveList$ (Nr!)
DECLARE SUB Switchdrive (lw$)
DECLARE SUB ExitBox (x!, y!)
DECLARE FUNCTION exist! (p$)
DECLARE SUB TextBox (Zeilen!, Spalten!, Text$, Break!)
DECLARE SUB Register (z!, s!, zu!, su!, Text$)
DECLARE SUB FrameWindow (a!, B!, c!, d!, del!)
DECLARE SUB Echo (Text$)
DECLARE SUB GetInp ()
DECLARE SUB Control (Zeilen!, Spalten!, Text$)
DECLARE SUB CLW ()
DECLARE FUNCTION Gerade! (zahl!)
DECLARE FUNCTION IsExist! (Datei$, InOrdner$)
DECLARE FUNCTION ComboBox$ (Nr!, z!, s!, zu!, su!)
DECLARE FUNCTION IsEmptyBox! (Ordner$)
DECLARE FUNCTION IsExistBox! (Box$)
DECLARE FUNCTION Trim$ (Variable$, Trennzeichen$, a!)
DECLARE FUNCTION MenuInt$ (Item$, Trennzeichen$)
DECLARE SUB Dialog (Caption$)
DECLARE SUB LoadSymbol (Name$, Kennung$)
DECLARE SUB ShowSymbols ()
DECLARE SUB Menuact (Menu$)
DECLARE SUB TimeLock (status!)
DECLARE SUB StoppUhrBeep (Uhr!)
DECLARE SUB Symbact (Symbol$)
DECLARE FUNCTION Getkey$ ()
DECLARE SUB ClearControls (Connect!)
DECLARE SUB NextControl ()
DECLARE SUB LastControl ()
DECLARE SUB Activate (Ctrl$)
DECLARE FUNCTION InputBox$ (Zeilen!, Spalten!, Text$, Break!, MaxDown!)
CLEAR

ON ERROR GOTO fehlernext
SCREEN 9
VIEW PRINT 1 TO 25
'    -> 640 x 350 Grafik
'     80 x 25 oder 80 x 43 Textformat, 8 x 14 oder 8 x 8 Zeichenfeldgre
'     Zuweisung von 16 Farben zu 4 Attributen (64 KB Adapterspeicher) oder
'      64 Farben zu 16 Attributen (mehr als 64 KB Adapterspeicher)
'     Falls 64KB EGA Adapterspeicher, 1 Bildschirmspeicherseite (0);
'      ansonsten 2 Seiten (0-1)

DIM SHARED Hintergrund(456) AS LONG
DIM SHARED StoppUhr(1 TO 4) AS SINGLE '1 ist Reserviert!
DIM SHARED AlteZeit(1 TO 4) AS LONG
DIM SHARED TextScale AS INTEGER
DIM SHARED TextBreak AS INTEGER
DIM SHARED Activ AS STRING
DIM SHARED ControlNr AS INTEGER
DIM SHARED ControlList(5) AS STRING
DIM SHARED Break AS INTEGER
DIM SHARED EBox.left AS INTEGER, EBox.top AS INTEGER
DIM SHARED Left AS INTEGER, Top AS INTEGER, Right AS INTEGER, Down AS INTEGER
DIM SHARED NextBreak AS INTEGER
DIM SHARED ControlConnect AS INTEGER 'Zur Unterscheidung der 3 Eingabecontrols
DIM SHARED Symbollist(0) AS STRING, SymbolNr AS INTEGER
DIM SHARED Symb.left AS INTEGER, Symb.top AS INTEGER, Symb.total AS INTEGER
DIM SHARED Symb.ipp AS INTEGER 'IPP=Icons par page (misst die letzte volle Seite)
DIM SHARED Symb.count 'Zhlt die Symbole in der aktuellen Seite
DIM SHARED DimY AS LONG, DimNow AS INTEGER, Symb.pnr'Nr. in der aktuellen Seite
DIM SHARED MenuList(4) AS STRING, MenuNr AS INTEGER
DIM SHARED Focus AS STRING
DIM SHARED keyb AS STRING
DIM SHARED Change(1) AS INTEGER
DIM SHARED errorlevel AS INTEGER
DIM SHARED choice AS INTEGER
DIM SHARED Combo(1 TO 1, 1 TO 100) AS STRING
DIM SHARED Pictures(1) AS STRING
DIM SHARED ActivItem AS STRING, DriveName AS STRING
DIM SHARED Texts(1 TO 100) AS STRING

FesteEinstellungen:
WIDTH 80, 25

Einstellungen:
DIM SHARED Fensterfarbe AS INTEGER, Randfarbe AS INTEGER, Schattenfarbe AS INTEGER, Controlfarbe AS INTEGER
DIM SHARED Symbolactiv AS INTEGER, SymbactStil AS INTEGER, SymbolFrame AS INTEGER, SymbolColor AS INTEGER
DIM SHARED Hintergrundfarbe  AS INTEGER, Farbe AS INTEGER, IconVerticalSpace AS INTEGER
DIM SHARED InfoTime AS INTEGER, InfoColor  AS INTEGER, InfoFrame, Datumsformat AS INTEGER

CLOSE 1: OPEN "c:\laos\config.lcg" FOR RANDOM AS 1
GET 1, 1, Schema$

DIM m(1 TO 15)

IF Schema$ <> "" THEN

IF LOF(1) <> 0 THEN
CLOSE 1: OPEN "c:\laos\" + Schema$ + ".scl" FOR INPUT AS 1: LINE INPUT #1, a$
FOR i = 1 TO 15
INPUT #1, m(i)
NEXT
ELSE m(10) = 15: m(1) = 14
END IF

ELSE m(10) = 15: m(1) = 14
END IF

Fensterfarbe = m(1)'Fensterfarben
Randfarbe = m(2)
Schattenfarbe = m(3)
Controlfarbe = m(4)  'Schaltflchenfarbe
Symbolactiv = m(5) 'Umrahmungsfarbe des aktiven Symbols
SymbactStil = m(6) 'Umrahmungs-Stil des aktivierten Symbols (-1=voll)

SymbolFrame = m(7) 'Farbe des Symbolrahmens
SymbolColor = m(8) 'Farbe des Symbolhintergrundes

Hintergrundfarbe = m(9) 'Bildschirmfarben
Farbe = m(10) '= Vordergrundfarbe

IconVerticalSpace = m(11) 'Setzt den Vertikalen Standard-Abstand der Symbole
                            'Auf Null gesetzt ist der Abstand gengend.
InfoTime = m(12)'Setzt die zu verstreichende Zeit in Sekunden, bis die Quick-
                  'Info erscheint. (0=Ausgeschaltet)
InfoColor = m(13) 'Setzt die Farbe, in der der Quick-Info-Text erscheint.
InfoFrame = m(14) 'Setzt die Farbe des Quick-Info-Rahmens.

Datumsformat = m(15)

ERASE m

CONST Fe1 = 6, Fe2 = 4, Fe3 = 75, Fe4 = 20 'Startfensterkoordinaten
StoppUhr(2) = 60 '2.Stoppuhr: Bildschirmschoner ausgeschaltet, da er zuviel Arbeitsspeicher braucht...


VorStart:
CLOSE
VIEW
COLOR Farbe, Hintergrundfarbe
SHELL "c:"
CHDIR "c:\laos"

Code = 0 'Legt die Ereignisverfolgung fr die Alt-Taste fest
FOR i = 15 TO 19
KEY i, CHR$(Code) + CHR$(56)
ON KEY(i) GOSUB AltKey
Code = Code + 32
NEXT i
Code = 0: i = 0

Programm:
'Schreiben Sie hier Ihren persnlichen Code:
DIM SHARED Changed AS INTEGER, EBox AS INTEGER, NoChanges AS INTEGER, AnzBuchungen AS INTEGER, glblstatus$, letsdelete%

TYPE moneycabtype
        Datum AS STRING * 10
        wert AS SINGLE
        lagerveraenderung AS SINGLE
        Produkt AS STRING * 12
        Bezeichnung AS STRING * 30
END TYPE
DIM SHARED moneycab AS moneycabtype

CLW
start:
Register 0, 0, 0, 0, "Moneycab Copyright (C) 2002, Urs Langmeier"
ExitBox -1, -1
IF NOT exist("moneycab.mcb") THEN CLOSE 1: OPEN "moneycab.mcb" FOR BINARY AS 1: CLOSE 1

ERASE Combo

Combo(1, 1) = "Transaktion erfassen"
Combo(1, 2) = "Statistiken"
Combo(1, 3) = "Buchungen Heute"
Combo(1, 4) = "-"
Combo(1, 5) = "Transaktionsstorno"
Combo(1, 6) = "Abschlsse"
Combo(1, 7) = "-"
Combo(1, 8) = "Beenden"

Register 15, 5, 23, 75, "Zusammenfassung"
StoppUhr(3) = .05
a$ = ComboBox(1, 5, 5, 12, 75)
StoppUhrBeep 5 'Ausrechnung zurcksetzen, um beim nchsten mal von vorne zu beginnen

IF keyb = "esc" OR a$ = "Beenden" THEN CHAIN "brmnager.mod"

IF AnzBuchungen > 90 THEN Dialog "Achtung: Ein Monatsabschluss sollte nchstens durchgefhrt werden, damit der Buchungsspeicher nicht berluft! berprfen Sie, ob Sie gegebenenfalls noch Buchungen stornieren mssen und fhren Sie dann einen Monatsabschluss durch. (Men Abschlsse->Monatsabschluss)"
IF AnzBuchungen > 98 THEN Dialog "Aufgrund des begrenzten Buchungsspeicher muss jetzt ein Monatsabschluss durchgefhrt werden! Drcken Sie die Eingabetaste, um nun einen Monatsabschluss durchzufhren.": Monatsabschluss 0

SELECT CASE choice
    CASE 3
        BuchungenHeute
    CASE 1
        TransaktionErfassen
    CASE 2
        Statistiken
    CASE 6
            Register 0, 0, 0, 0, "moneycab Abschlsse"
            ERASE Combo
            Combo(1, 1) = "Monatsabschluss"
            Combo(1, 2) = "Jahresabschluss"
            Combo(1, 3) = "-"
            Combo(1, 4) = "Zurck"
            ActivItem = ""
            a$ = ComboBox(1, 7, 5, 14, 75)
            IF keyb = "esc" THEN GOTO start
                SELECT CASE choice
                CASE 1: Monatsabschluss -1
                CASE 2: Jahresabschluss
                END SELECT
    CASE 5
        TransaktionsStorno

    '...
END SELECT
GOTO start

CHAIN "brmnager.mod"
TimeEreignis:
TIMER OFF
RETURN


AltKey:
IF MenuList(1) <> "" THEN Activate CHR$(0): ControlConnect = 1: Activate MenuList(1): MenuNr = 1: GetInp
RETURN

fehlernext:
errorlevel = 1
RESUME NEXT

CHAIN "brmnager.mod"

SUB Activate (Ctrl$)
SELECT CASE ControlConnect
CASE 0 'Controls
i = 0
DO
i = i + 1
a$ = ControlList(i)
Activ = Ctrl$
IF a$ = "" THEN EXIT SUB
'ControlNr = i
Zeilen = VAL(MID$(a$, 1, 2))
Spalten = VAL(MID$(a$, 3, 2))
Texta$ = MID$(a$, 5)
Control Zeilen, Spalten, Texta$
LOOP UNTIL a$ = ""
CASE 1 'Menus
i = 0
Activ = Ctrl$
DO
i = i + 1
a$ = MenuList(i)
IF a$ = "" THEN EXIT DO
Menuact a$
LOOP UNTIL a$ = ""
Focus = MID$(Ctrl$, 5)


CASE 2 'Symbole
i = 0
Activ = Ctrl$
'i = Symb.total * Symb.page
DO
i = i + 1
a$ = Symbollist(i)
IF MID$(a$, 15) = Activ THEN Activ = a$
IF a$ = "" THEN EXIT DO
Symbact a$
LOOP UNTIL a$ = ""
END SELECT
END SUB

SUB BesonderesList
'wichtig: MakeTotallyList muss in aufrufender Prozedur bereits ausgefhrt sein!!!

Register 0, 0, 0, 0, "Detaillierte Zusammenfassung"

ERASE Texts
start% = 1

TimeLock 1
CreateDetail "Abschreibungen", "Abschreibung", start%
TimeLock 1
CreateDetail "Verkufe auf Kredit", "Verkauf auf Kredit", start%
TimeLock 1
CreateDetail "Stornierte Buchungen", "", start%
TimeLock 0

NoChanges = -1
EditBox 4, 2, 23, 79
NoChanges = 0

END SUB

SUB BuchungenHeute

IF exist(LEFT$(DATE$, 2) + MID$(DATE$, 4, 2) + RIGHT$(DATE$, 4) + ".mcb") THEN MakeTotallyList 8: file$ = "mcb.tmp" ELSE file$ = "moneycab.mcb"

errorlevel = 0
CLOSE 1
OPEN file$ FOR INPUT AS 1
IF errorlevel THEN Dialog "Buchungsdatei kann nicht geffnet werden.": EXIT SUB

ERASE Texts
totalwert = 0
lager = 0
start% = 1
SetTexts start%, "", start%
SetTexts start%, "Buchungen Heute", start%
SetTexts start%, STRING$(18, CHR$(196)), start%
start% = 5

DO WHILE NOT EOF(1)
    INPUT #1, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung
IF moneycab.Datum = SDate$(DATE$) OR moneycab.Datum = DATE$ THEN
        SetTexts start%, moneycab.Datum + " " + Franken(moneycab.wert) + " (" + Produktwert(moneycab.lagerveraenderung) + ", " + moneycab.Produkt + "), " + moneycab.Bezeichnung, start%
            totalwert = totalwert + moneycab.wert
            lager = lager + moneycab.lagerveraenderung
END IF
LOOP

IF start% = 5 THEN
SetTexts start%, "Noch keine Buchungen heute.", start%


ELSE
SetTexts start%, SPACE$(11) + STRING$(20, CHR$(196)), start%
SetTexts start%, SPACE$(11) + Franken(totalwert) + "  " + Produktwert(lager), start%
SetTexts start%, SPACE$(11) + STRING$(20, CHR$(205)), start%

END IF

NoChanges = -1
EditBox 4, 2, 23, 79
NoChanges = 0


END SUB

SUB ClearBox (Zeilen, Spalten, Caption$)

a = Spalten * 8 - 11: B = Zeilen * 14 - 17: c = (Spalten + LEN(Caption$)) * 8 - 5
d = (Zeilen + 1) * 14 - 11

'Lschen:
LINE (a - 2, B - 2)-(c + 2, d + 2), 0, BF

END SUB

SUB ClearControls (Connect)
Activ = ""
SELECT CASE Connect
CASE 0: ControlNr = 0: ERASE ControlList
CASE 1: MenuNr = 0: ERASE MenuList
CASE 2: SymbolNr = 0: ERASE Symbollist: Symb.left = 0: Symb.top = 0: Symb.total = 0
CASE 3 'Alle lschen
ControlNr = 0: ERASE ControlList
MenuNr = 0: ERASE MenuList
SymbolNr = 0: ERASE Symbollist: Symb.left = 0: Symb.top = 0: Symb.total = 0
END SELECT
ControlConnect = 0

END SUB

SUB CLW
'Fenster:
LINE (2, 2)-(637, 347), 0, BF
LINE (0, 0)-(638, 348), Fensterfarbe, B
'Schatten:
LINE (1, 1)-(637, 1), Schattenfarbe
LINE (1, 1)-(1, 347), Schattenfarbe
'Rand:
LINE (639, 349)-(0, 349), Randfarbe
LINE (639, 349)-(639, 0), Randfarbe

TextScale = 2 '=Zeile
TextBreak = 2 '=Spalte
EBox.left = 603: EBox.top = 321
Left = 2: Top = 2: Right = 79: Down = 24
END SUB

FUNCTION ComboBox$ (Nr, z, s, zu, su)

IF Hintergrundfarbe = 12 THEN Vorgehoben% = 14 ELSE Vorgehoben% = 12

IF Combo(Nr, 1) = "" THEN Combo(Nr, 1) = " "
DIM Trenner(1 TO 5)


MaxItem% = 30000

IF z = 0 THEN z = Top
IF s = 0 THEN s = Left
IF zu = 0 THEN zu = Down
IF su = 0 THEN su = Right

MaxLenth = su - s + 1
MaxDown = zu - z + 1

DO
i = i + 1
IF Combo(Nr, i) = "-" THEN Combo(Nr, i) = STRING$(MaxLenth, 196): tr = tr + 1: Trenner(tr) = standort + i
LOOP UNTIL Combo(Nr, i) = ""


a = s * 8 - 11
B = z * 14 - 17
c = su * 8 + 1
d = zu * 14 + 1


FrameWindow a, B, c, d, 0

ItemPos = 1
ItemPage = 1

IF ActivItem <> "" THEN act$ = ActivItem: zrl = 1: GOTO aktivieren
weiter2:

DO

 standort = ItemPage * MaxDown - MaxDown + 1
LOCATE z

 FOR i = 0 TO MaxDown - 1
  IF standort + i <= MaxItem% THEN
  IF LEN(Combo(Nr, (standort + i))) <= MaxLenth THEN
  Eintrag$ = Combo(Nr, standort + i) + SPACE$(MaxLenth - LEN(Combo(Nr, standort + i)))
  ELSE
  Eintrag$ = LEFT$(Combo(Nr, standort + i), MaxLenth)
  END IF
  ELSE Eintrag$ = SPACE$(MaxLenth)
  END IF

   IF standort + i = ItemPos THEN COLOR InfoColor ELSE COLOR Farbe

   SELECT CASE LEFT$(Eintrag$, 2)
    CASE "A ", "B ": COLOR Vorgehoben%
   END SELECT

LOCATE , s
   IF LEFT$(Eintrag$, 1) = CHR$(0) THEN
    COLOR Farbe: PRINT MID$(Eintrag$, 2) + " "
    FOR y = 1 TO 14 STEP 2
        LINE (s * 8 - 9, (z + i) * 14 - 14 + y)-(su * 8, (z + i) * 14 - 14 + y), 0
    NEXT
   ELSE
    PRINT Eintrag$
   END IF

    IF i = 0 THEN LINE (s * 8 - 9, (z + i) * 14 - 15)-(su * 8, (z + i) * 14), 0, B ELSE LINE (s * 8 - 9, (z + i) * 14 - 14)-(su * 8, (z + i) * 14), 0, B
 NEXT i

i = ItemPos - standort
LINE (s * 8 - 9, (z + i) * 14 - 15)-(su * 8, (z + i) * 14), InfoFrame, B

SELECT CASE Getkey
CASE "up"
ItemPos = ItemPos - 1

FOR i = 1 TO UBOUND(Trenner)
IF Trenner(i) = ItemPos THEN ItemPos = ItemPos - 1
NEXT
IF ItemPos < standort THEN ItemPage = ItemPage - 1


CASE "down"
IF ItemPos < MaxItem% THEN

IF Combo(Nr, ItemPos + 1) <> "" THEN

ItemPos = ItemPos + 1

FOR i = 1 TO UBOUND(Trenner)
IF Trenner(i) = ItemPos THEN ItemPos = ItemPos + 1
NEXT


IF ItemPos > standort + MaxDown - 1 THEN ItemPage = ItemPage + 1

END IF
END IF

CASE "home"
    ItemPos = 1
    ItemPage = 1
    IF Trenner(1) = 1 THEN ItemPos = ItemPos + 1

CASE "end"
    DO
        ItemPos = ItemPos + 1
        standort = ItemPage * MaxDown - MaxDown + 1
        IF ItemPos > standort + MaxDown THEN ItemPage = ItemPage + 1
    LOOP UNTIL Combo(1, ItemPos) = ""
        ItemPos = ItemPos - 1

    FOR i = 1 TO UBOUND(Trenner)
        IF Trenner(i) = ItemPos THEN ItemPos = ItemPos - 1
    NEXT

CASE "pageup"
IF ItemPos - MaxDown > 0 THEN
    ItemPage = ItemPage - 1
    ItemPos = ItemPos - MaxDown
END IF
CASE "pagedown"
IF ItemPos + MaxDown < MaxItem% + 1 THEN
IF Combo(Nr, ItemPos + MaxDown) <> "" THEN
ItemPage = ItemPage + 1
ItemPos = ItemPos + MaxDown
END IF
END IF
CASE CHR$(13), "esc", "tab", "shifttab"
    LINE (s * 8 - 9, (z + i) * 14 - 15)-(su * 8, (z + i) * 14), 0, B
    choice = ItemPos: ComboBox = Combo(Nr, ItemPos): GOTO ExitBox

CASE "delete"
IF letsdelete% THEN
    LINE (s * 8 - 9, (z + i) * 14 - 15)-(su * 8, (z + i) * 14), 0, B
    choice = ItemPos: ComboBox = Combo(Nr, ItemPos): GOTO ExitBox
ELSE GOTO 9015
END IF

CASE ELSE
9015
IF LEN(keyb) = 1 THEN
act$ = keyb
aktivieren:

AltePosition = ItemPos
AlteSeite = ItemPage

DO
 ItemPos = ItemPos + 1
 IF ItemPos = AltePosition THEN ItemPage = AlteSeite: EXIT DO
 standort = ItemPage * MaxDown - MaxDown + 1
 IF ItemPos > standort + MaxDown - 1 THEN ItemPage = ItemPage + 1

   Eintrag$ = LEFT$(Combo(Nr, ItemPos), MaxLenth)
   IF Eintrag$ = "" OR ItemPos > MaxItem% - 1 THEN ItemPos = 0: ItemPage = 1

LOOP UNTIL LCASE$(LEFT$(Eintrag$, LEN(act$))) = LCASE$(act$)
GOTO weiter2

END IF

END SELECT

FOR i = 1 TO UBOUND(Trenner)
IF Trenner(i) = ItemPos THEN ItemPos = ItemPos + 1
NEXT

IF ItemPos < 1 THEN ItemPos = 1: ItemPage = 1
IF Combo(Nr, ItemPos) = "" THEN ItemPos = ItemPos - 1
IF ItemPos < 1 THEN ItemPos = 1: ItemPage = 1

LOOP

ExitBox:
COLOR Farbe
END FUNCTION

SUB Control (Zeilen, Spalten, Text$)

IF TextScale = 0 THEN TextScale = Top
IF TextBreak = 0 THEN TextBreak = Left
IF Zeilen = 0 THEN Zeilen = TextScale
IF Spalten = 0 THEN Spalten = TextBreak
IF Zeilen > Down THEN Zeilen = Top: Spalten = NextBreak + 1: TextScale = Top: TextBreak = NextBreak

IF LEN(Text$) + Spalten + 2 > NextBreak THEN NextBreak = LEN(Text$) + Spalten + 2


a = Spalten * 8 - 11
B = Zeilen * 14 - 17
EndSpalte = Spalten + LEN(Text$)
EndZeile = Zeilen + INT(LEN(Text$) / 80 + 1)
IF LEN(Text$) = 80 THEN EndZeile = EndZeile - 1
c = EndSpalte * 8 - 5
d = EndZeile * 14 - 11

LOCATE Zeilen, Spalten: COLOR Farbe: PRINT Text$
'LINE (a, B)-(c, d), Farbe, B
'PAINT (a + 1, B + 1), Controlfarbe, Farbe
LINE (a, B)-(c, d), Controlfarbe, B

'Schatten: (Wird angezeigt, falls das Control aktiviert ist.
IF Activ = Text$ THEN
LINE (a + 1, B + 1)-(c - 1, B + 1), Schattenfarbe
LINE (a + 1, B + 1)-(a + 1, d - 1), Schattenfarbe
ELSE
LINE (a + 1, B + 1)-(c - 1, B + 1), 0
LINE (a + 1, B + 1)-(a + 1, d - 1), 0
END IF
'Rand:
LINE (c + 1, d + 1)-(a, d + 1), Randfarbe
LINE (c + 1, d + 1)-(c + 1, B), Randfarbe


Zeilen$ = MID$(STR$(Zeilen), 2)
Spalten$ = MID$(STR$(Spalten), 2)
IF LEN(Zeilen$) < 2 THEN Zeilen$ = "0" + Zeilen$
IF LEN(Spalten$) < 2 THEN Spalten$ = "0" + Spalten$

'Control eintragen:
a$ = Zeilen$ + Spalten$ + Text$
i = 0
DO: i = i + 1
IF ControlList(i) = a$ THEN GOTO 2
LOOP UNTIL ControlList(i) = ""
ControlList(i) = a$
ControlNr = 1


2 Activ = Text$: ControlConnect = 0: TextScale = Zeilen + 2
END SUB

FUNCTION CoSinus (Winkel)
    CoSinus = COS(Winkel * (PI / 180))
END FUNCTION

SUB CreateDetail (Detailname$, Buchungstext$, start%)

totalwert = 0
lager = 0
SetTexts start%, "", start%
SetTexts start%, Detailname$, start%
SetTexts start%, STRING$(LEN(Detailname$) + 3, CHR$(196)), start%

errorlevel = 0
CLOSE 1
OPEN "mcb.tmp" FOR INPUT AS 1
IF errorlevel THEN Dialog "Buchungsdatei kann nicht geffnet werden.": EXIT SUB

DO WHILE NOT EOF(1)
    INPUT #1, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung
IF LTRIM$(Trim$(moneycab.Datum, CHR$(0), 1)) <> "" THEN
        IF LEFT$(moneycab.Bezeichnung, LEN(Buchungstext$)) = Buchungstext$ THEN
            SetTexts start%, moneycab.Datum + " " + Franken(moneycab.wert) + " (" + Produktwert(moneycab.lagerveraenderung) + ", " + moneycab.Produkt + "), " + moneycab.Bezeichnung, start%
            totalwert = totalwert + moneycab.wert
            lager = lager + moneycab.lagerveraenderung
        END IF
END IF
LOOP
SetTexts start%, SPACE$(11) + STRING$(20, CHR$(196)), start%
SetTexts start%, SPACE$(11) + Franken(totalwert) + "  " + Produktwert(lager), start%
SetTexts start%, SPACE$(11) + STRING$(20, CHR$(205)), start%

END SUB

SUB DeleteSaleDestItem (verkaufspunkt$)

CLOSE 1
                OPEN "saledest.bnk" FOR INPUT AS #1
                f% = FREEFILE
                OPEN "saledest.tmp" FOR OUTPUT AS #f%

                errorlevel = 0
                DO WHILE NOT EOF(1)
                        LINE INPUT #1, a$
                        IF a$ <> verkaufspunkt$ THEN PRINT #f%, a$
                        IF errorlevel THEN Dialog "Ein Fehler ist beim Lschen des Verkaufspunktes aufgetreten. Bitte neustarten und erneut versuchen.": CLOSE 1, f%: EXIT SUB
                LOOP
                CLOSE 1, f%

                IF errorlevel = 0 THEN KILL "saledest.bnk": NAME "saledest.tmp" AS "saledest.bnk" ELSE Dialog "Ein Fehler ist beim Lschen des Verkaufspunktes aufgetreten. Bitte neustarten und erneut versuchen."

END SUB

SUB Dialog (Caption$)
'Formatoptionen: gleich wie echo. Standard: "c"=zentriert
PartFormat Caption$, fmt$

IF LEN(Caption$) < 22 THEN Caption$ = STRING$(INT((22 - LEN(Kennung$)) / 2), " ") + Caption$ + STRING$(CINT((22 - LEN(Kennung$)) / 2 + .1), " ")

IF LEN(Caption$) > 303 THEN Caption$ = LEFT$(Caption$, 300) + "..."
IF LEN(Caption$) > 76 THEN Length = 76 ELSE Length = LEN(Caption$)
Spalten = INT(40 - Length / 2 + 1)
Zeilen = 11 - INT(LEN(Caption$) / 76) + 1

x1! = Spalten * 8 - 11
y1! = Zeilen * 14 - 17
EndSpalten = 40 + INT(Length / 2)
EndZeilen = 14 + INT(LEN(Caption$) / 76)
IF INT(LEN(Caption$) / 76) > 1 THEN EndZeilen = EndZeilen - (INT(LEN(Caption$) / 76) - 1)
IF LEN(Caption$) < 76 THEN EndZeilen = EndZeilen + 1
x2! = EndSpalten * 8 + 4
y2! = EndZeilen * 14 - 4
Groesse = 4 + INT(((PMAP(x2!, 0) - PMAP(x1!, 0) + 1) * (1) + 7) / 8) * 2 * (PMAP(y2!, 1) - PMAP(y1!, 1) + 1)
REDIM Background(Groesse) AS INTEGER


GET (x1!, y1!)-(x2!, y2!), Background

FrameWindow x1!, y1!, x2! - 1, y2! - 1, 1

a% = TextBreak: B% = TextScale: c% = Right: d% = Down
    TextBreak = Spalten
    TextScale = Zeilen
    Right = EndSpalten
    Down = EndZeilen

        IF fmt$ = "" THEN fmt$ = "c"
        Echo Caption$ + Format(fmt$)

Zeilen = TextScale
TextBreak = a%: TextScale = B%: Right = c%: Down = d%

TextBox Zeilen + 1, 33, "      OK", 14

DO
B$ = a$
a$ = Getkey
LOOP UNTIL a$ = "esc" OR a$ = CHR$(13)
IF a$ = "esc" THEN keyb = "esc" ELSE keyb = B$
PUT (x1!, y1!), Background, PSET: x1! = 0: y1! = 0
REDIM Background(0) AS INTEGER
EXIT SUB

END SUB

FUNCTION DriveList$ (Nr)
Nr = Nr - 1

DO
Nr = Nr + 1
CLOSE 1: OPEN "c:\laos\drvlist.bnk" FOR RANDOM AS 1
GET 1, Nr, a$
LOOP WHILE NOT exist(LEFT$(a$, 1) + ":\nul") AND a$ <> ""

DriveList = LEFT$(a$, 1)
CLOSE 1
DriveName = MID$(a$, 4)
END FUNCTION

SUB Echo (Txt$)
PartFormat Txt$, fmt$

'Format: "l", "c", "r": Linksbndig, zentriert, rechtsbndig

SELECT CASE fmt$
    CASE "l", "": Align% = 0
    CASE "c": Align% = 1
    CASE "r": Align% = 2
END SELECT

IF TextScale = 0 THEN TextScale = Top
IF TextBreak = 0 THEN TextBreak = Left
IF TextScale > Down THEN TextScale = Top

'10.11.1999: Echo mit Zeilenumbruch (C) Urs Langmeier.

Text$ = Txt$ + " "

DIM s AS INTEGER, z AS INTEGER, t AS INTEGER, brk AS INTEGER


s = 1
z = Right - TextBreak + 2'Zeilenlnge
dwn = 0

p1% = s
p2% = p1%
DO
    t = t + 1
        IF t = p1% THEN p2% = p1%'alten Retten
        p1% = INSTR(t, Text$, " ")
        IF p1% = 0 OR p1% = LEN(Text$) THEN
            IF p1% <= s + z - 1 THEN p2% = LEN(Text$): brk = -1
        END IF

        IF p1% > s + z - 1 OR brk THEN 'nehme alten, weil neuen ber die Zeile ragt.
            'Zeile ausgeben:
            p1% = p2%
            IF TextScale + dwn > Down THEN EXIT DO
                IF p1% - s <= 0 THEN 'falls Wort zu lange (nicht in die Zeile passt:)

                    p1% = s + z - 1
                    a$ = MID$(Text$, s, p1% - s)
                    t = p1% - 1
                    s = t + 1

                ELSE

                    a$ = MID$(Text$, s, p1% - s)
                    t = p1% + 1
                    s = t
                END IF

            'Ausrichtung:
            SELECT CASE Align%
                CASE 0: x% = TextBreak
                CASE 1: x% = TextBreak + FIX((Right - TextBreak - LEN(a$) + 1) / 2)
                CASE 2: x% = Right - LEN(a$) + 1
            END SELECT

            LOCATE TextScale + dwn, x%
            PRINT a$;

            dwn = dwn + 1
        END IF
LOOP UNTIL t >= LEN(Text$)
TextScale = TextScale + dwn


END SUB

SUB EditBox (z, s, zu, su)
MaxItem% = 100
Changed = 0
IF z = 0 THEN z = Top
IF s = 0 THEN s = Left
IF zu = 0 THEN zu = Down
IF su = 0 THEN su = Right

MaxLenth = su - s + 1
MaxDown = zu - z + 1


a = s * 8 - 11
B = z * 14 - 17
c = su * 8 + 1
d = zu * 14 + 1

dok.up = 1
Screen.Z = 1
Screen.S = 1
Box.Left = s
Box.Top = z
Box.Right = su
Box.Down = zu

Setting:
FOR Nr = 1 TO MaxItem%
Texts(Nr) = LEFT$(Texts(Nr), MaxLenth)
Texts(Nr) = Texts(Nr) + SPACE$(MaxLenth - LEN(Texts(Nr)))
NEXT Nr


NeuRahmen:
FrameWindow a, B, c, d, 0


Refreshing:
rf = 0
IF dok.up < 1 THEN dok.up = 1: Screen.Z = 1: Screen.S = 1

i = 0
FOR Nr = dok.up TO MaxItem%
i = i + 1
IF i <= MaxDown THEN
    LOCATE Box.Top + i - 1, Box.Left: PRINT Texts(Nr)

t$ = Texts(Nr)
FOR jo% = 1 TO LEN(t$)
    IF MID$(t$, jo%, 1) = "-" THEN
        IF VAL(MID$(t$, jo% + 1, 1)) <> 0 OR MID$(t$, jo% + 1, 1) = "0" THEN
            FOR n% = jo% TO LEN(t$)
                IF VAL(MID$(t$, n%, 2)) <> 0 OR MID$(t$, n%, 1) = "0" OR MID$(t$, n%, 1) = "." OR MID$(t$, n%, 1) = "-" THEN
                    COLOR 12
                    LOCATE Box.Top + i - 1, Box.Left + n% - 1
                    PRINT MID$(t$, n%, 1)
                    COLOR Farbe
                END IF
                IF MID$(t$, n%, 1) = " " THEN jo% = n%: EXIT FOR
            NEXT
        END IF
    END IF
NEXT



END IF
NEXT Nr
GOTO Cursor

LinePrint:
LOCATE Box.Top + Screen.Z - 1, Box.Left
t$ = Texts(dok.up + Screen.Z - 1)
PRINT t$
FOR jo% = 1 TO LEN(t$)
    IF MID$(t$, jo%, 1) = "-" THEN
        IF VAL(MID$(t$, jo% + 1, 1)) <> 0 OR MID$(t$, jo% + 1, 1) = "0" THEN
            FOR n% = jo% TO LEN(t$)
                IF VAL(MID$(t$, n%, 2)) <> 0 OR MID$(t$, n%, 1) = "0" OR MID$(t$, n%, 1) = "." OR MID$(t$, n%, 1) = "-" THEN
                    COLOR 12
                    LOCATE Box.Top + Screen.Z - 1, Box.Left + n% - 1
                    PRINT MID$(t$, n%, 1)
                    COLOR Farbe
                END IF
                IF MID$(t$, n%, 1) = " " THEN jo% = n%: EXIT FOR
            NEXT
        END IF
    END IF
NEXT

Cursor:
LOCATE Box.Top + Screen.Z - 1, Box.Left + Screen.S - 1
LINE (POS(0) * 8, CSRLIN * 14 - 1)-(POS(0) * 8 - 8, CSRLIN * 14 - 1), InfoColor


728
Keyboard:
EBox = 1
a$ = Getkey
EBox = 0
IF Activ <> "" THEN EXIT SUB

LINE (POS(0) * 8, CSRLIN * 14 - 1)-(POS(0) * 8 - 8, CSRLIN * 14 - 1), 0
IF a$ = CHR$(0) + "T" THEN a$ = CHR$(174)
IF a$ = CHR$(0) + "U" THEN a$ = CHR$(175)

SELECT CASE a$
CASE CHR$(12): 'Unterstreichen:
IF NoChanges THEN 728
a$ = CHR$(196): GOTO 42
CASE "tab"
sz$ = Texts(dok.up + Screen.Z - 1)

IF RTRIM$(MID$(sz$, Screen.S)) = "" THEN
Screen.S = Screen.S + 8
IF Screen.S > MaxLenth THEN Screen.S = MaxLenth
ELSE
DO
Screen.S = INSTR(Screen.S + 1, sz$, " ") + 1
LOOP UNTIL MID$(sz$, Screen.S, 1) <> " "
IF Screen.S < 1 THEN Screen.S = 1
IF Screen.S > MaxLenth THEN Screen.S = MaxLenth
END IF

CASE "end"
Screen.S = LEN(RTRIM$(Texts(dok.up + Screen.Z - 1))) + 1


CASE "home"
Screen.S = 1


CASE "pageup"
dok.up = dok.up - 1
GOTO Refreshing

CASE "pagedown"
dok.up = dok.up + 1
IF dok.up > MaxItem% THEN dok.up = MaxItem%
GOTO Refreshing


CASE "insert"
IF NoChanges THEN 728
sz$ = Texts(dok.up + Screen.Z - 1)
links = Screen.S
IF links < 0 THEN links = 0
sz$ = LEFT$(sz$, links - 1) + " " + MID$(sz$, links)
sz$ = LEFT$(sz$, MaxLenth)
Texts(dok.up + Screen.Z - 1) = sz$


CASE "delete"
IF NoChanges THEN 728
sz$ = Texts(dok.up + Screen.Z - 1)

IF RTRIM$(sz$) = "" THEN
FOR Nach = dok.up + Screen.Z TO MaxItem%
Texts(Nach - 1) = Texts(Nach)
NEXT Nach
Texts(MaxLenth) = SPACE$(MaxLenth)
GOTO Refreshing
END IF

links = Screen.S
IF links < 1 THEN links = 1
sz$ = LEFT$(sz$, links - 1) + MID$(sz$, links + 1)
sz$ = sz$ + SPACE$(MaxLenth - LEN(sz$))
Texts(dok.up + Screen.Z - 1) = sz$


CASE CHR$(8)
IF NoChanges THEN 728
IF Screen.S > 1 THEN
sz$ = Texts(dok.up + Screen.Z - 1)
links = Screen.S - 1
IF links < 1 THEN links = 1
sz$ = LEFT$(sz$, links - 1) + MID$(sz$, links + 1)
sz$ = LEFT$(sz$, MaxLenth)
sz$ = sz$ + SPACE$(MaxLenth - LEN(sz$))
Texts(dok.up + Screen.Z - 1) = sz$
Screen.S = Screen.S - 1

ELSE
Screen.S = MaxLenth: Screen.Z = Screen.Z - 1

IF Screen.Z < 1 THEN
Screen.Z = 1: dok.up = dok.up - 1
IF dok.up < 1 THEN dok.up = 1: Screen.Z = 1: Screen.S = 1
Screen.S = LEN(RTRIM$(Texts(dok.up + Screen.Z - 1))) + 1
GOTO Refreshing
ELSE Screen.S = LEN(RTRIM$(Texts(dok.up + Screen.Z - 1))) + 1
END IF

END IF


CASE "down"
Screen.Z = Screen.Z + 1
IF Screen.Z > MaxDown THEN Screen.Z = MaxDown: dok.up = dok.up + 1: GOTO Refreshing


CASE "up"
Screen.Z = Screen.Z - 1
IF Screen.Z < 1 THEN Screen.Z = 1: dok.up = dok.up - 1: GOTO Refreshing



CASE "left"
Screen.S = Screen.S - 1

IF Screen.S < 1 THEN
Screen.S = MaxLenth: Screen.Z = Screen.Z - 1

IF Screen.Z < 1 THEN
Screen.Z = 1: dok.up = dok.up - 1

IF dok.up < 1 THEN dok.up = 1: Screen.Z = 1: Screen.S = 1
Screen.S = LEN(RTRIM$(Texts(dok.up + Screen.Z - 1))) + 1
GOTO Refreshing

ELSE Screen.S = LEN(RTRIM$(Texts(dok.up + Screen.Z - 1))) + 1
END IF

END IF



CASE "right"
Screen.S = Screen.S + 1
IF Screen.S > MaxLenth THEN Screen.S = 1: Screen.Z = Screen.Z + 1
IF Screen.Z > MaxDown THEN Screen.Z = MaxDown: dok.up = dok.up + 1: GOTO Refreshing

CASE "esc": EXIT SUB

CASE CHR$(13)
IF NoChanges THEN 728
IF Screen.S = 1 THEN
FOR Nach = MaxItem% TO dok.up + Screen.Z STEP -1
Texts(Nach) = Texts(Nach - 1)
NEXT Nach
Texts(dok.up + Screen.Z - 1) = SPACE$(MaxLenth)
rf = 1
END IF
Screen.S = 1
Screen.Z = Screen.Z + 1

IF Screen.Z > MaxDown THEN Screen.Z = MaxDown: dok.up = dok.up + 1: GOTO Refreshing

CASE ELSE
IF NoChanges THEN 728
42
Changed = -1
sz$ = Texts(dok.up + Screen.Z - 1)
links = Screen.S - 1
IF links < 0 THEN links = 0
sz$ = LEFT$(sz$, links) + a$ + MID$(sz$, links + 1)
sz$ = LEFT$(sz$, MaxLenth)
Texts(dok.up + Screen.Z - 1) = sz$
Screen.S = Screen.S + LEN(a$)
IF Screen.S > MaxLenth THEN LOCATE Box.Top + Screen.Z - 1, Box.Left: PRINT Texts(dok.up + Screen.Z - 1): Screen.S = 1: Screen.Z = Screen.Z + 1
IF Screen.Z > MaxDown THEN Screen.Z = MaxDown: dok.up = dok.up + 1: GOTO Refreshing
END SELECT

IF rf = 1 THEN GOTO Refreshing
GOTO LinePrint
END SUB

FUNCTION ende (Nr)
zero = 1
FOR a = Nr + 1 TO 100
IF RTRIM$(Texts(a)) <> "" THEN zero = 0: EXIT FOR
NEXT
ende = zero
END FUNCTION

FUNCTION exist (p$)
f% = FREEFILE
ae% = errorlevel
errorlevel = 0
OPEN p$ FOR INPUT AS f%
IF errorlevel = 0 THEN exist = -1 ELSE exist = 0
CLOSE f%
errorlevel = ae%
END FUNCTION

SUB ExitBox (x, y)
IF x = -1 THEN x = EBox.left
IF y = -1 THEN y = EBox.top
LINE (x, y)-(x + 26, y + 20), Fensterfarbe, B
LINE (x + 1, y + 1)-(x + 25, y + 1), Schattenfarbe
LINE (x + 1, y + 1)-(x + 1, y + 19), Schattenfarbe
LINE (x, y + 21)-(x + 26, y + 21), Randfarbe
LINE (x + 27, y + 21)-(x + 27, y), Randfarbe

LINE (x + 2, y + 19)-(x + 24, y + 2), Fensterfarbe
LINE (x + 3, y + 19)-(x + 25, y + 2), Schattenfarbe
LINE (x + 2, y + 2)-(x + 24, y + 19), Fensterfarbe
LINE (x + 3, y + 2)-(x + 25, y + 19), Schattenfarbe

END SUB

SUB FileCopy (Source$, Dest$, capt$)

Register 8, 20, 15, 60, ""
Echo ""
Echo " " + capt$

errorlevel = 0
f% = FREEFILE
OPEN Source$ FOR BINARY AS f%
 whole = LOF(f%) \ 500
 part = LOF(f%) MOD 500
 buffer$ = STRING$(500, 0)
 start& = 1

f2% = FREEFILE
OPEN Dest$ FOR BINARY AS f2%: CLOSE f2%: KILL Dest$ 'stellt sicher, dass Dest$ leer ist.
OPEN Dest$ FOR BINARY AS f2%
  FOR x = 1 TO whole
       GET f%, start&, buffer$
       PUT f2%, start&, buffer$
       start& = start& + 500
     p% = INT(100 * LOF(f2%) / LOF(f%))
     ProgressBar p%
  NEXT x

 buffer$ = STRING$(part, 0)
  GET f%, start&, buffer$
  PUT f2%, start&, buffer$

ProgressBar 100

IF errorlevel THEN Dialog "Beim kopieren der Datei ist ein Fehler aufgetreten. Vielleicht ist zuwenig Speicherplatz verfgbar, oder der Datentrger ist schreibgeschtzt."

CLOSE f%, f2%

END SUB

SUB FillDatesBetweenToFile (datum1$, datum2$, fout%)

DIM tag1 AS INTEGER, tag2 AS INTEGER, monat1 AS INTEGER, monat2 AS INTEGER, jahr1 AS INTEGER, jahr2 AS INTEGER
DIM datvon AS DOUBLE, datbis AS DOUBLE
'12.03.2002 tt.mm.jjjj

tag1 = VAL(LEFT$(datum1$, 2))
tag2 = VAL(LEFT$(datum2$, 2))

monat1 = VAL(MID$(datum1$, 4, 2))
monat2 = VAL(MID$(datum2$, 4, 2))

jahr1 = VAL(RIGHT$(datum1$, 4))
jahr2 = VAL(RIGHT$(datum2$, 4))

datvon = CDBL(jahr1) * 365 + monat1 * 31 + tag1
datbis = CDBL(jahr2) * 365 + monat2 * 31 + tag2

'IF tag1 = 31 AND monat1 = 3 THEN STOP

DO

tag1 = tag1 + 1
datvon = datvon + 1
SELECT CASE monat1
CASE 1, 3, 5, 7, 8, 10, 12
    IF tag1 > 31 THEN tag1 = 1: monat1 = monat1 + 1
CASE 2, 4, 6, 9, 11
    IF tag1 > 30 THEN tag1 = 1: monat1 = monat1 + 1
END SELECT

IF monat1 > 12 THEN monat1 = 1: jahr1 = jahr1 + 1

IF datvon >= datbis THEN EXIT DO
'IF tag1 >= tag2 AND monat1 >= monat2 AND jahr1 >= jahr2 THEN EXIT DO

    WRITE #fout%, zr(tag1) + "." + zr(monat1) + "." + zr(jahr1), 0, 0, "", ""

LOOP UNTIL datvon >= datbis




END SUB

FUNCTION Format$ (FormatString AS STRING)
    Format$ = CHR$(0) + FormatString
END FUNCTION

SUB FormatToWaehrung (w$) 'Formatiert string w$ als Whrung...

'richtiges Formatieren:
IF INSTR(w$, ".") = 0 THEN w$ = w$ + ".--"
IF MID$(w$, LEN(w$) - 1, 1) = "." THEN w$ = w$ + "0"

END SUB

SUB Frame
'Frame kann ausgefhrt werden, um ein Rahmen um das Fenster zu machen,
'und dabei aber die Left- Top- usw.-Kordinaten zu behalten.
'einzig die TextScale- und TextBreak- Koordinaten wechseln nach oben links.
'-> Siehe auch die Sub "CLW".

FrameWindow 0, 0, 638, 348, 0

'EBox.left = 603: EBox.top = 321
'Left = 2: Top = 2: Right = 79: Down = 24
TextScale = 2: TextBreak = 2
END SUB

SUB FrameWindow (a, B, c, d, del)
'Erstellt ein Fenster, ohne dabei die Umgebungsvariablen zu verndern
'Wahlweise wird der Inhalt des Fensters gelscht (del = 1), oder nicht.

'Fenster:
LINE (a, B)-(c, d), Fensterfarbe, B
IF del = 1 THEN LINE (a + 2, B + 2)-(c - 1, d - 1), 0, BF
'Schatten:
LINE (a + 1, B + 1)-(c - 1, B + 1), Schattenfarbe
LINE (a + 1, B + 1)-(a + 1, d - 1), Schattenfarbe
'Rand:
LINE (c + 1, d + 1)-(a, d + 1), Randfarbe
LINE (c + 1, d + 1)-(c + 1, B), Randfarbe

END SUB

FUNCTION Franken$ (wert)
w$ = RTRIM$(LTRIM$(STR$(wert)))

'richtiges Formatieren:
IF INSTR(w$, ".") = 0 THEN w$ = w$ + ".--"
IF MID$(w$, LEN(w$) - 1, 1) = "." THEN w$ = w$ + "0"

errorlevel = 0
Franken$ = SPACE$(10 - LEN(w$)) + w$
IF errorlevel THEN Franken$ = "xxxxxx.xx"

END FUNCTION

FUNCTION FU$ (a$, x)
'Hngt a$ soviele Leerzeichen an, bis es die Lnge x hat

IF LEN(a$) > x THEN a$ = LEFT$(a$, x - 3) + "..."
FU = a$ + STRING$(x - LEN(a$), " ")

END FUNCTION

FUNCTION Gerade (zahl)
IF zahl / 2 - FIX(zahl / 2) = 0 THEN Gerade = 1:  ELSE Gerade = 0
END FUNCTION

FUNCTION GetDebitor$ (namen$, wert$)
'Sucht nach einem Debitor mit dem bestimmten namen$, und gibt das generierte
'Debitoren-Adressfile als Funktionsergebnis zurck.

'Sucht nach den Datensatz:
'
'Der Datensatz wird definiert durch die Daten in folgenden globalen Variablen:
'vorname$, nachname$, strasse$, ort$, telefon$, Texts(1 to 4)

DIM Temp AS STRING, STexts AS STRING, i AS INTEGER, Index AS INTEGER

z = TIMER + .2
TimeLock 1

CLOSE 1
IF exist("index.tmp") THEN KILL "index.tmp"

OPEN "kunden.bnk" FOR INPUT AS 1
sucherg = FREEFILE
OPEN "sucherg.tmp" FOR OUTPUT AS #sucherg
Findex = FREEFILE
OPEN "index.tmp" FOR RANDOM AS #Findex


Index = 0
DO WHILE NOT EOF(1)

IF TIMER > z THEN z = TIMER + .2: TimeLock 1
Index = Index + 1
'Datensatz einlesen:
errorlevel = 0
LINE INPUT #1, Svorname$
IF errorlevel THEN Dialog "Fehler. Kontaktieren Sie den Hersteller. Fehler-Info: goto suchenabbruch, sub SuchListe": GOTO suchenabbruch
LINE INPUT #1, Snachname$
LINE INPUT #1, Sstrasse$
LINE INPUT #1, Sort$
LINE INPUT #1, Stelefon$
FOR i = 1 TO 4
    LINE INPUT #1, STexts$
NEXT

'eingelesener Datensatz (S...) mit Suchkriterien vergleichen:
IF INSTR(LCASE$(Svorname$), LCASE$(namen$)) OR INSTR(LCASE$(Snachname$), LCASE$(namen$)) OR namen$ = "" THEN

'Falls bereinstimmend, der Suchergebnisliste hinzufgen:
PRINT #sucherg, FU(Svorname$, 20); " "; FU(Snachname$, 22); " "; FU(Stelefon$, 20); " "; FU(Sstrasse$, 20); FU(Sort$, 20); FU(STexts, 168); ""

'Datensatz-Index wird in Indexliste gespeichert:
PUT #Findex, , Index

END IF
LOOP

suchenabbruch:
CLOSE #sucherg, #Findex
TimeLock 0


ListeLaden:
Register 0, 0, 0, 0, "Debitoren"
ERASE Combo

CLOSE 1: OPEN "sucherg.tmp" FOR INPUT AS 1
errorlevel = 0
i = 0
DO WHILE NOT EOF(1)
i = i + 1
LINE INPUT #1, a$
IF i >= 99 THEN Dialog "Zuviele Datenstze gefunden. Bitte lschen Sie einige Debitoren aus der Debitoren-Adressdatenbank!": keyb = "esc": errorlevel = 1: EXIT FUNCTION
Combo(1, i) = a$

LOOP

IF i = 0 THEN Dialog "Kein registrierter Kunde mit diesem Namen gefunden. Bitte tragen Sie den Kunden zuerst in der Kunden-Adressdatenbank ein.": keyb = "esc": errorlevel = 1: EXIT FUNCTION

DO
ActivItem = ComboBox(1, 4, 4, 23, 68)

IF keyb = "esc" THEN EXIT FUNCTION

IF keyb = CHR$(13) THEN
'Datensatz wird geladen:
CLOSE 1: OPEN "index.tmp" FOR RANDOM AS 1
GET 1, choice, i

CLOSE 1
OPEN "kunden.bnk" FOR INPUT AS 1

z% = 0
DO WHILE NOT EOF(1)
        z% = z% + 1

LINE INPUT #1, vorname$
LINE INPUT #1, nachname$
LINE INPUT #1, strasse$
LINE INPUT #1, ort$
LINE INPUT #1, telefon$

FOR u = 1 TO 4
LINE INPUT #1, Texts(u)
NEXT

IF z% >= i THEN EXIT DO
LOOP

CLOSE 1
f% = FREEFILE
i = 0
DO
i = i + 1
a$ = "deb" + LTRIM$(STR$(i))
LOOP WHILE exist(a$ + ".deb")

GetDebitor$ = a$
DIM Debitor AS Debitortype

OPEN a$ + ".deb" FOR OUTPUT AS f%
WRITE #f%, VAL(wert$), SDate$(DATE$)
CLOSE f%
OPEN "debitors.bnk" FOR RANDOM AS f% LEN = 554
i% = 0
DO
    i% = i% + 1
    GET f%, i%, Debitor
LOOP WHILE LTRIM$(Trim(Debitor.Adresse, CHR$(0), 1)) <> ""

Debitor.Konto = a$ + ".deb"
Debitor.Adresse = vorname$ + " " + nachname$ + CHR$(13) + strasse$ + CHR$(13) + ort$ + CHR$(13) + telefon$ + CHR$(13)
FOR u = 1 TO 4
    Debitor.Adresse = RTRIM$(Debitor.Adresse) + CHR$(13) + Texts(u)
NEXT

PUT f%, i%, Debitor
CLOSE f%

EXIT FUNCTION
END IF

LOOP 'Eingabeschleife

END FUNCTION

SUB GetInp
DIM kbd AS STRING
'Aktiviere das Control mit dem Fokus:
SELECT CASE ControlConnect
CASE 0: Activate MID$(ControlList(ControlNr), 5)
CASE 1: Activate MenuList(MenuNr)
CASE 2: Activate Symbollist(SymbolNr)
END SELECT


DO
FOR i = 15 TO 19: KEY(i) ON: NEXT i
IF InfoTime > 0 THEN
TIMER ON
ON TIMER(InfoTime) GOSUB TimeEreignis
END IF
  FOR i = 1 TO 4
    AlteZeit(i) = TIMER
  NEXT i
WHILE INKEY$ = CHR$(13) OR INKEY$ = CHR$(27): WEND
kbd = ""
 WHILE kbd = ""
  kbd = INKEY$
   FOR i = 1 TO 4
     IF StoppUhr(i) > 0 THEN
       IF TIMER - AlteZeit(i) > StoppUhr(i) THEN StoppUhrBeep (i): AlteZeit(i) = TIMER
     END IF
   NEXT i
 WEND
TIMER OFF: FOR i = 15 TO 19: KEY(i) OFF: NEXT i

SELECT CASE kbd
CASE "?": KILL "timeout.tmp": CHAIN "brmnager.mod"
CASE CHR$(0) + "G": DO: a$ = Activ: LastControl: LOOP UNTIL a$ = Activ OR INKEY$ <> ""
CASE CHR$(0) + "O": DO: a$ = Activ: NextControl: LOOP UNTIL a$ = Activ OR INKEY$ <> ""
CASE CHR$(13)
SELECT CASE ControlConnect
CASE 0: Focus = MID$(ControlList(ControlNr), 5)
CASE 1: Focus = MID$(MenuList(MenuNr), 5)
CASE 2: Focus = MID$(Symbollist(SymbolNr), 15)
END SELECT
keyb = kbd
EXIT SUB
CASE CHR$(9) 'Tab
STATIC ch AS INTEGER

Activate CHR$(0) 'Aktiviere ein Control, das gar nicht existiert, um alle
                 'anderen zu deaktivieren.
ControlConnect = ControlConnect + 1
IF ControlConnect > 2 THEN ControlConnect = 0
FOR i = 1 TO 3
SELECT CASE ControlConnect
CASE 0: IF ControlList(1) = "" THEN ControlConnect = 1
CASE 1: IF Change(ch + 1) <> 0 THEN ControlConnect = 0: EXIT FOR
        IF MenuList(1) = "" THEN ControlConnect = 2
CASE 2: IF Symbollist(1) = "" THEN ControlConnect = 0
END SELECT
NEXT i
SELECT CASE ControlConnect
CASE 0
ch = ch + 1
IF Change(ch) = 0 THEN ch = 0
IF ch <> 0 THEN ControlNr = Change(ch)
Activate MID$(ControlList(ControlNr), 5)
CASE 1: Activate MenuList(MenuNr)
CASE 2: Activate Symbollist(SymbolNr)
END SELECT
CASE CHR$(0) + "H", CHR$(0) + "K": LastControl
CASE CHR$(0) + "P", CHR$(0) + "M": NextControl
CASE CHR$(27), CHR$(8)
keyb = "esc": EXIT SUB'Minimize
END SELECT
LOOP

END SUB

FUNCTION Getkey$

  FOR i = 1 TO 4
    AlteZeit(i) = TIMER
  NEXT i

FOR i = 15 TO 19: KEY(i) ON: NEXT i
a$ = ""

WHILE a$ = "": a$ = INKEY$
        IF EBox = 1 AND Activ <> "" THEN EXIT FUNCTION
        IF ControlConnect > 0 THEN Getkey = CHR$(13): EXIT FUNCTION
   FOR i = 1 TO 4
     IF StoppUhr(i) > 0 THEN
       IF TIMER - AlteZeit(i) > StoppUhr(i) THEN StoppUhrBeep (i): AlteZeit(i) = TIMER
     END IF
   NEXT i

WEND

SELECT CASE MID$(a$, 2)
CASE "?": KILL "timeout.tmp": CHAIN "brmnager.mod"
CASE CHR$(15): a$ = "shifttab"
CASE "H": a$ = "up"
CASE "P": a$ = "down"
CASE "K": a$ = "left"
CASE "M": a$ = "right"
CASE "R": a$ = "insert"
CASE "S": a$ = "delete"
CASE "G": a$ = "home"
CASE "O": a$ = "end"
CASE "I": a$ = "pageup"
CASE "Q": a$ = "pagedown"
END SELECT

SELECT CASE ASC(a$)
CASE 27: a$ = "esc"
CASE 9: a$ = "tab"
END SELECT

Getkey = a$
keyb = a$
END FUNCTION

FUNCTION GetLager (Produkt$)

errorlevel = 0
f% = FREEFILE
OPEN "moneycab.mcb" FOR INPUT AS f%
IF errorlevel THEN Dialog "Buchungsdatei fr die Ermittlung des Lagerbestandes kann nicht geffnet werden.": EXIT FUNCTION

'Zeilen aus Logbuch einlesen:
lager = 0
DO WHILE NOT EOF(f%)
        INPUT #f%, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung
IF LTRIM$(Trim$(moneycab.Datum, CHR$(0), 1)) <> "" THEN
        IF RTRIM$(moneycab.Produkt) = RTRIM$(Produkt$) THEN lager = lager + moneycab.lagerveraenderung
END IF
LOOP
CLOSE f%
GetLager = lager
errorlevel = 0
END FUNCTION

SUB GetOKParity (Bezeichnung$, wert$, lager$)
'kehrt die werte um, falls sie fr den aktuellen Buchungssatz zwingend
'positiv oder negativ sein mssen, um falsche Buchungen zu vermeiden.
DIM paritywert AS INTEGER, paritylager AS INTEGER

SELECT CASE Bezeichnung$
CASE "Einkauf in Sortiment"'-200.--;+5p
paritywert = -1
paritylager = 1

CASE "Nachbestellung"'-200.--;+5p
paritywert = -1
paritylager = 1

CASE "Erhalt Muster/Geschenk"'+200.-- / +4p
paritywert = 1
paritylager = 1

CASE "Bestandeskorrektur Eigenbedarf"'-4p
paritywert = 0
paritylager = -1

CASE "Bestandeskorrektur Diebstahl"'-4p
paritywert = 0
paritylager = -1

CASE "Buchungsstorno"'+/-200.-- / ; +/-4p
paritywert = 7
paritylager = 7

CASE "Umtausch Ausbuchung"
paritywert = 7
paritylager = -1

CASE "Umtausch Einbuchung"
paritywert = 7
paritylager = 1

CASE "Eigenkapital Einlage"'+200.--
paritywert = 1
paritylager = 1

CASE "Eigenkapital Rcknahme"'-200.--
paritywert = -1
paritylager = -1

CASE "Ausserordentlicher Ertrag" '+200, +4p
paritywert = 1
paritylager = 1

CASE ELSE
paritylager = 7
paritywert = 7

END SELECT

IF LEFT$(Bezeichnung$, 7) = "Verkauf" THEN  'Verkauf  +200.--;-5
    paritywert = 1
    paritylager = -1
END IF

IF LEFT$(Bezeichnung$, 12) = "Abschreibung" THEN 'Abschreibung ... -200.--;-5p
    paritywert = -1
    paritylager = -1
END IF


SELECT CASE paritywert
    CASE -1:  IF VAL(wert$) > 0 THEN wert$ = LTRIM$(STR$(VAL(wert$) * -1))
    CASE 1:  IF VAL(wert$) < 0 THEN wert$ = LTRIM$(STR$(VAL(wert$) * -1))
    CASE 0: wert$ = SPACE$(LEN(wert$))
END SELECT

SELECT CASE paritylager
    CASE -1: IF VAL(lager$) > 0 THEN lager$ = LTRIM$(STR$(VAL(lager$) * -1))
    CASE 1: IF VAL(lager$) < 0 THEN lager$ = LTRIM$(STR$(VAL(lager$) * -1))
    CASE 0: lager$ = SPACE$(LEN(lager$))
END SELECT
IF VAL(lager$) > 0 AND LEFT$(lager$, 1) <> "+" THEN lager$ = "+" + lager$

END SUB

FUNCTION GetValidPassword% (checksum, password$)
a = 0
FOR i% = 1 TO LEN(password$)
    a = a / 2 + ASC(MID$(password$, i%, 1))
NEXT

IF a = checksum THEN GetValidPassword% = -1 ELSE GetValidPassword% = 0

END FUNCTION

SUB Graph (a, B, c, d, file$, fr) 'fr 1 =franken, 0 = wert

min = 0
max = 0
anzahlzahlen = 0
'zuerst muss die kleinste und die grsste Zahl innerhalb des Graph bestimmt
'werden:
f% = FREEFILE
OPEN file$ FOR INPUT AS f%
errorlevel = 0
Text2$ = ""
DO WHILE NOT EOF(f%)
        INPUT #f%, Text$, wert
        IF errorlevel THEN EXIT DO
        IF Text$ <> Text2$ THEN anzahlzahlen = anzahlzahlen + 1
        Text2$ = Text$
        IF wert < min THEN min = wert
        IF wert > max THEN max = wert
LOOP
CLOSE f%

'Rahmen zeichnen:
LINE (a, B)-(c, d), InfoColor, B
LINE (a - 1, B - 1)-(c - 2, B - 1), InfoColor
LINE (a - 1, B - 1)-(a - 1, d - 2), InfoColor


'Daten einlesen:
OPEN file$ FOR INPUT AS f%

'ersten Wert einlesen:
IF NOT EOF(f%) THEN

        'Gleiche Texte zusammenbinden, das heisst, nur letzter Wert in Stat-
        'istik aufnehmen:
        wert2 = 0
        Text2$ = ""
        DO
            wert = wert2
            Text$ = Text2$

            INPUT #f%, Text2$, wert2
            IF errorlevel THEN EXIT DO

        LOOP UNTIL Text2$ <> Text$ AND (Text$ <> "" OR wert <> 0)

END IF

spanne = max - min
letzterx = 0
letztery = (wert * (d - B) / spanne) - (min * (d - B) / spanne)
xspace = (c - a) / (anzahlzahlen - 1)'damit es fr jeden Wert Platz hat...
letztespalte = 0

errorlevel = 0
DO WHILE NOT EOF(f%)

        'zeitachsenbeschriftung:
        TextScale = INT(d / 14) + 2
        TextBreak = INT((a + letzterx) / 8) + 1'=Spalte
        IF TextBreak >= letztespalte + 2 OR letztespalte = 0 THEN
                Echo Text$
                letztespalte = TextBreak + LEN(Text$)
                LINE (a + letzterx, d - 3)-(a + letzterx, d + 3), Farbe
        END IF

        'Gleiche Texte zusammenbinden, das heisst, nur letzter Wert in Stat-
        'istik aufnehmen:
        DO
            wert = wert2
            Text$ = Text2$

            INPUT #f%, Text2$, wert2
            IF errorlevel THEN EXIT DO

        LOOP UNTIL Text2$ <> Text$ 'AND (Text$ <> "" OR wert <> 0)

'SLEEP
        neuery = (wert * (d - B) / spanne) - (min * (d - B) / spanne)
        LINE (a + letzterx, d - letztery)-(a + letzterx + xspace, d - neuery), Farbe

        letztery = neuery
        letzterx = letzterx + xspace

LOOP



'wertachsenbeschriftung:
'der bersicht halber soll maximal alle drei Zeilen soll eine Beschriftung
'gesetzt werden:

Right = INT(a / 8) - 1
Left = 1
TextBreak = 1
TextScale = 0

abstand = (d - B) / 14 / 5
yabstand = (d - B) / abstand
spannabstand = (max - min) / abstand

y = d
zahl = min

FOR i% = 1 TO INT(abstand) + 1
        TextScale = INT(y / 14) + 1
        IF fr = 0 THEN Echo STR$(CINT(zahl)) + Format("r") ELSE Echo Franken(CINT(zahl)) + Format("r")
        neuery = (zahl * (d - B) / spanne) - (min * (d - B) / spanne)
        LINE (a - 3, d - neuery)-(a + 3, d - neuery), Farbe
        zahl = zahl + spannabstand
        y = y - yabstand
NEXT

'hchsten Wert falls es nicht aufgeht manuell setzen:
IF INT(abstand) <> abstand THEN
        y = B
        zahl = max
        TextScale = INT(y / 14) + 1
        IF fr = 0 THEN Echo STR$(CINT(zahl)) + Format("r") ELSE Echo Franken(CINT(zahl)) + Format("r")
        neuery = (zahl * (d - B) / spanne) - (min * (d - B) / spanne)
        LINE (a - 3, d - neuery)-(a + 3, d - neuery), Farbe
END IF


END SUB

SUB GraphicView (a, B, c, d)
'Diese Sub ndert die Umgebungsvariablen (Left, Top, usw.) fr einen bestimmt-
'en Fenster-Bereich. Die darauffolgenden Grafikausgaben erfolgen in diesem
'Bereich.
'LINE (a, B)-(c, d), Randfarbe, B



EBox.left = c - 31: EBox.top = d - 24
Left = INT(a / 8) + 2: Top = INT(B / 14) + 2: Right = INT((c + 8) / 8) - 1: Down = INT((d + 14) / 14) - 1
TextBreak = Left
TextScale = Top
END SUB

FUNCTION InputBox$ (Zeilen, Spalten, Text$, Break, MaxDown)
'Break=Zeilenumbruch | MaxDown=Maximale Zeilen
IF Text$ = CHR$(0) THEN HidePasswordChar = -1: Text$ = ""

IF TextScale = 0 THEN TextScale = Top
IF TextBreak = 0 THEN TextBreak = Left
IF Zeilen = 0 THEN Zeilen = TextScale
IF Spalten = 0 THEN Spalten = TextBreak + 1

IF Break = 0 OR Break > Right - Spalten THEN Break = Right - Spalten
IF MaxDown = 0 THEN MaxDown = 24 - Zeilen
TotalBreak = Break
Texta$ = Text$: a$ = ""
GOTO Deletefirst

lesen:
a$ = Getkey

IF a$ = CHR$(13) THEN InputBox$ = Texta$: GOTO delcur
IF a$ = "up" OR a$ = "down" OR a$ = "left" OR a$ = "right" OR a$ = "tab" THEN InputBox$ = Texta$: GOTO delcur
IF a$ = "esc" THEN InputBox$ = Texta$: GOTO delcur
IF a$ = CHR$(8) THEN
IF RIGHT$(Texta$, 3) = ".--" THEN Texta$ = LEFT$(Texta$, LEN(Texta$) - 2)
IF LEN(Texta$) > 0 THEN Texta$ = LEFT$(Texta$, LEN(Texta$) - 1)
LINE (a, B)-(c + 1, d + 1), 0, BF
a$ = ""
END IF
IF dwn > MaxDown THEN a$ = "": nocur = 1

IF LEN(a$) = 1 THEN Texta$ = Texta$ + a$
Break = LEN(Texta$) + 1

Deletefirst:
Break = LEN(Texta$) + 1
dwn = INT(LEN(Texta$) / TotalBreak) + 1
IF Break > TotalBreak THEN Break = TotalBreak: nocur = 1
IF LEN(Texta$) < (INT(LEN(Texta$) / TotalBreak) + 1) * TotalBreak AND LEN(Texta$) > INT(LEN(Texta$) / TotalBreak) * TotalBreak THEN nocur = 0

a = Spalten * 8 - 11
B = Zeilen * 14 - 17
EndSpalte = Spalten + Break
EndZeile = Zeilen + INT(LEN(Texta$) / Break + 1)
IF dwn > MaxDown AND MaxDown > 1 THEN EndZeile = EndZeile - 1
IF Break = LEN(Texta$) THEN EndZeile = EndZeile - 1
c = EndSpalte * 8 - 5
d = EndZeile * 14 - 11

FrameWindow a, B, c, d, 1


ecr = TotalBreak * -1 + 1
FOR i = 1 TO INT(LEN(Texta$) / TotalBreak) + 1
LOCATE Zeilen + i - 1, Spalten
ecr = ecr + TotalBreak
IF HidePasswordChar THEN PRINT MID$(STRING$(LEN(Texta$), "*"), ecr, TotalBreak);  ELSE PRINT MID$(Texta$, ecr, TotalBreak);
NEXT i
ecr = 0

IF nocur = 0 THEN LINE (POS(0) * 8, CSRLIN * 14)-(POS(0) * 8 - 8, CSRLIN * 14 - 14), InfoColor, BF ELSE nocur = 0
GOTO lesen

delcur:
LINE (POS(0) * 8, CSRLIN * 14)-(POS(0) * 8 - 8, CSRLIN * 14 - 14), 0, BF

END FUNCTION

FUNCTION IsEmptyBox (Ordner$)

CLOSE 1: OPEN "DATEIEN.BNK" FOR RANDOM AS #1 LEN = 400
FIELD 1, 11 AS Dateiname$, 16 AS Art$, 11 AS Symbol$, 32 AS OsName$, 32 AS InOrdner$, 11 AS link$, 10 AS Datum$, 5 AS Zeit$, 1 AS Attribut$, 256 AS FileInfo$

TimeLock (1)
AlteZeit = TIMER
DO
GET 1
IF RTRIM$(InOrdner$) = Ordner$ THEN IsEmptyBox = 0: TimeLock (0): EXIT FUNCTION

IF TIMER - AlteZeit > .5 THEN TimeLock (1): AlteZeit = TIMER
LOOP UNTIL Dateiname$ = STRING$(11, 0)
TimeLock (0)

IsEmptyBox = 1'Box ist leer
END FUNCTION

FUNCTION IsExist (Datei$, InOrdner$)

CLOSE 1: OPEN "DATEIEN.BNK" FOR RANDOM AS #1 LEN = 400
FIELD 1, 11 AS Dateiname$, 16 AS Art$, 11 AS Symbol$, 32 AS OsName$, 32 AS Ordner$, 11 AS link$, 10 AS Datum$, 5 AS Zeit$, 1 AS Attribut$, 256 AS FileInfo$

a = 0
DO
a = a + 1
GET 1, a
IF Datei$ = RTRIM$(OsName$) AND InOrdner$ = RTRIM$(Ordner$) THEN IsExist = 1: EXIT FUNCTION
IF Datei$ = RTRIM$(OsName$) AND InOrdner$ = "" THEN IsExist = 1: EXIT FUNCTION
LOOP UNTIL Dateiname$ = STRING$(11, 0)

IsExist = 0


END FUNCTION

FUNCTION IsExistBox (Box$)

CLOSE 1: OPEN "ORDNER.BNK" FOR RANDOM AS 1
i = 0
DO
i = i + 1
GET 1, i, a$
IF a$ = Box$ THEN IsExistBox = 1: EXIT FUNCTION
LOOP UNTIL a$ = ""

IsExistBox = 0
END FUNCTION

SUB Jahresabschluss
    Register 4, 20, 18, 60, "Monatsabschluss"
    ExitBox -1, -1
    Echo ""
    Echo "Hiermit werden smtliche Buchungs- dateien archiviert. Stornierungen vergangener Buchungen knnen keine mehr durchgefhrt werden, und die Umsatz- und Verkaufs-Statistiken beginnen von vorne."
    Echo ""
    COLOR InfoColor
    Echo "Mchten Sie jetzt fortfahren?"
    COLOR Farbe
    a$ = InputBox(15, 22, "", 4, 1)
    IF a$ <> "ja" OR keyb = "esc" THEN EXIT SUB

file$ = RIGHT$(DATE$, 4) + ".mca" 'Verzeichnis, wohin die Dateien archiviert werden...
IF exist(file$ + "\nul") THEN Dialog "Es wurde diesen Monat bereits einen Jahresabschluss durchgefhrt. Es kann maximal ein Jahresabschluss pro Monat durchgefhrt werden! Alternativ knnen Sie aber tglich einen Monatsabschluss durchfhren!": EXIT SUB

MKDIR file$
IF NOT exist(file$ + "\nul") THEN Dialog "Verzeichnis fr das Archiv konnte nicht erstellt werden! Kontaktieren Sie den Hersteller."

Monatsabschluss 0

SHELL "dir *.mcb /a:-d /b >moneycab.tmp"
f% = FREEFILE
    OPEN "moneycab.tmp" FOR INPUT AS f%

DO WHILE NOT EOF(f%)
    LINE INPUT #f%, a$
    IF LCASE$(a$) <> "moneycab.mcb" THEN
        errorlevel = 0
        FileCopy a$, file$ + "\" + a$, "Archivieren: Monatsabschluss vom  " + SDate$(LEFT$(a$, 2) + "-" + MID$(a$, 3, 2) + "-" + MID$(a$, 5, 4))
            IF errorlevel = 0 THEN KILL a$
    END IF
LOOP
CLOSE f%

FileCopy "mcbmoa.rsc", file$ + "\mcbmoa.rsc", "Archivieren: Liste der Monatsabschlsse"
KILL "mcbmoa.rsc"

Dialog "Der Jahresabschluss wurde durchgefhrt."
END SUB

FUNCTION LaOSFileName$ (DosFile$)

CLOSE 1: OPEN "\laos\DATEIEN.BNK" FOR RANDOM AS #1 LEN = 400
FIELD 1, 11 AS Dateiname$, 16 AS Art$, 11 AS Symbol$, 32 AS OsName$, 32 AS Ordner$, 11 AS link$, 10 AS Datum$, 5 AS Zeit$, 1 AS Attribut$, 256 AS FileInfo$
a = 0
DO
a = a + 1
GET 1, a
IF RTRIM$(Dateiname$) = DosFile$ THEN LaOSFileName = RTRIM$(OsName$): EXIT FUNCTION
LOOP UNTIL Dateiname$ = STRING$(11, 0)

END FUNCTION

SUB LastControl
'Wird von GetInp verwendet.

SELECT CASE ControlConnect
CASE 0
ControlNr = ControlNr - 1
IF ControlNr < 1 THEN ControlNr = 1
i = 0
DO
i = i + 1
a$ = ControlList(i)
Activ = MID$(ControlList(ControlNr), 5)
Zeilen = VAL(MID$(a$, 1, 2))
Spalten = VAL(MID$(a$, 3, 2))
Texta$ = MID$(a$, 5)
IF a$ = "" THEN EXIT DO
Control Zeilen, Spalten, Texta$
LOOP UNTIL a$ = ""
CASE 1
MenuNr = MenuNr - 1
IF MenuNr < 1 THEN MenuNr = 1
Activate MenuList(MenuNr)
CASE 2
Symb.pnr = Symb.pnr - 1
SymbolNr = SymbolNr - 1
IF SymbolNr < 1 THEN SymbolNr = 1: Symb.pnr = 1
IF Symb.pnr < 1 THEN

pagerows% = FIX((Down - Top - 4) / (IconVerticalSpace + 4)) + 1

i = SymbolNr
rows% = 0
y2 = VAL(MID$(Symbollist(i), 4, 3))
DO
    i = i - 1
    y = VAL(MID$(Symbollist(i), 4, 3))
    IF y < y2 THEN
        y2 = y
        rows% = rows% + 1
    END IF

LOOP UNTIL rows% >= pagerows%

DimNow = 1
SymbolNr.old = SymbolNr
SymbolNr = SymbolNr - ABS(i - SymbolNr)
IF SymbolNr < 0 THEN SymbolNr = 0
LINE (Left * 8 - 8, Top * 14 - 14)-(Right * 8, Down * 14), 0, BF
ShowSymbols
SymbolNr = SymbolNr.old
Symb.pnr = Symb.count
END IF
Activate Symbollist(SymbolNr)
END SELECT
END SUB

FUNCTION LinkIt$
CLOSE 1: OPEN "c:\laos\linkway.tmp" FOR RANDOM AS 1
GET 1, 1, a$
LinkIt = a$
CLOSE 1
END FUNCTION

SUB ListeKontobuch

Register 0, 0, 0, 0, "Monatsjournal"

errorlevel = 0
CLOSE 1
OPEN "moneycab.mcb" FOR INPUT AS 1
IF errorlevel THEN Dialog "Buchungsdatei kann nicht geffnet werden.": EXIT SUB

ERASE Texts

'Zeile aus Logbuch einlesen:
start% = 1
totalwert = 0'Variable fr die zu errechnende Totalsumme
lager = 0
DO WHILE NOT EOF(1)
    INPUT #1, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung
IF LTRIM$(Trim$(moneycab.Datum, CHR$(0), 1)) <> "" THEN
        SetTexts start%, moneycab.Datum + " " + Franken(moneycab.wert) + " (" + Produktwert(moneycab.lagerveraenderung) + ", " + moneycab.Produkt + "), " + moneycab.Bezeichnung, start%
        totalwert = totalwert + moneycab.wert
        lager = lager + moneycab.lagerveraenderung
END IF
LOOP
SetTexts start% + 1, STRING$(50, CHR$(196)) + Format("c"), start%
SetTexts start%, "Bruttoerls: " + Franken(totalwert) + "   Lager total: " + STR$(lager) + Format("c"), start%
SetTexts start%, STRING$(50, CHR$(205)) + Format("c"), start%

NoChanges = -1
EditBox 4, 2, 23, 79
NoChanges = 0

END SUB

SUB LoadPicture (PNr, Bild$, InOrdner$)

CLOSE 1: OPEN "DATEIEN.BNK" FOR RANDOM AS #1 LEN = 400
FIELD 1, 11 AS Dateiname$, 16 AS Art$, 11 AS Symbol$, 32 AS OsName$, 32 AS Ordner$, 11 AS link$, 10 AS Datum$, 5 AS Zeit$, 1 AS Attribut$, 256 AS FileInfo$

a = 0
DO
a = a + 1
GET 1, a
IF RTRIM$(OsName$) = Bild$ AND RTRIM$(Ordner$) = InOrdner$ THEN EXIT DO
LOOP UNTIL RTRIM$(Dateiname$) = ""
IF RTRIM$(Dateiname$) = "" THEN errorlevel = 1: EXIT SUB

Pictures(PNr) = Dateiname$
errorlevel = 0
END SUB

SUB LoadSymbol (Name$, Kennung$)
Symb.total = Symb.total + 1

IF LEN(Kennung$) < 4 THEN Kennung$ = Kennung$ + SPACE$(4 - LEN(Kennung$))


IF Symb.left = 0 THEN Symb.left = Left
IF Symb.top = 0 THEN Symb.top = Top

x = (Symb.left - 2 + LEN(Kennung$) / 2) * 8
y = Symb.top * 14

IF (INT(x / 8)) + 4 - CINT(LEN(Kennung$) / 2) + LEN(Kennung$) > Right THEN
x = (Left - 2 + LEN(Kennung$) / 2) * 8: Symb.left = Left: Symb.top = Symb.top + 4 + IconVerticalSpace: y = Symb.top * 14
END IF

Symb.left = (INT(x / 8)) + 4 - CINT(LEN(Kennung$) / 2) + LEN(Kennung$)

'Symbol eintragen:

x$ = MID$(STR$(x), 2)
IF LEN(x$) < 3 THEN x$ = STRING$(3 - LEN(x$), "0") + x$

y$ = MID$(STR$(y), 2)
IF LEN(y$) < 3 THEN y$ = STRING$(3 - LEN(y$), "0") + y$

IF LEN(Name$) < 8 THEN Name$ = Name$ + STRING$(8 - LEN(Name$), " ")

a$ = x$ + y$ + Name$ + RTRIM$(Kennung$)

i = 0
DO: i = i + 1: LOOP UNTIL Symbollist(i) = ""
Symbollist(i) = a$
SymbolNr = 0
END SUB

SUB Loesche (AlterName$)
CLOSE 1: OPEN "DATEIEN.BNK" FOR RANDOM AS #1 LEN = 400
FIELD 1, 11 AS Dateiname$, 16 AS Art$, 11 AS Symbol$, 32 AS OsName$, 32 AS Ordner$, 11 AS link$, 10 AS Datum$, 5 AS Zeit$, 1 AS Attribut$, 256 AS FileInfo$

a = 0
DO
a = a + 1
GET 1, a
IF RTRIM$(Dateiname$) = AlterName$ THEN

errorlevel = 0
KILL RTRIM$(Dateiname$)
IF errorlevel = 1 THEN KILL RTRIM$(Dateiname$) + ".lao"

DO 'Eintrag lschen
a = a + 1
GET 1, a
PUT 1, a - 1
LOOP UNTIL Dateiname$ = STRING$(11, 0)

errorlevel = 0
EXIT SUB
END IF
LOOP UNTIL Dateiname$ = STRING$(11, 0)

END SUB

SUB MakeTotallyList (status%)
STATIC totallylistgeneratet%
IF status% = 0 THEN totallylistgeneratet% = 0
IF status% = 7 THEN 9001 'ohne Abfrage fr Monat generieren
IF status% = 8 THEN 9002 'ohne Abfrage fr Jahr generieren
IF NOT totallylistgeneratet% THEN totallylistgeneratet% = -1 ELSE EXIT SUB

ERASE Combo
Combo(1, 1) = "Monat"
Combo(1, 2) = "Jahr"
Register 8, 30, 11, 50, "Anzeigen fr..."
a$ = ComboBox(1, 0, 0, 0, 0)
IF a$ = "Monat" THEN
9001
    glblstatus$ = "Monat"
    FileCopy "moneycab.mcb", "mcb.tmp", "Statistikdaten aufbereiten..."
    EXIT SUB
END IF

9002
glblstatus$ = "Jahr"
nz = TIMER + .5
TimeLock 1

f% = FREEFILE
OPEN "mcbmoa.rsc" FOR INPUT AS f%

fout% = FREEFILE
OPEN "mcb.tmp" FOR OUTPUT AS fout%
fin% = FREEFILE
errorlevel = 0

DO WHILE NOT EOF(f%)
    LINE INPUT #f%, a$
    IF a$ = "" THEN EXIT DO
    OPEN a$ FOR INPUT AS #fin%
IF errorlevel THEN Dialog "Keine oder fehlende Monatsabschlsse vorhanden.": EXIT DO
        DO WHILE NOT EOF(fin%)
            INPUT #fin%, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung
                IF errorlevel THEN EXIT DO 'tritt auf, falls ein Zeilenvorschub dem MCB-File am Schluss angehngt ist...
            IF UCASE$(LEFT$(moneycab.Bezeichnung, 8)) <> "BERTRAG" AND UCASE$(LEFT$(moneycab.Bezeichnung, 8)) <> "BERTRAG" THEN WRITE #fout%, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung
            IF TIMER >= nz THEN TimeLock 1: nz = TIMER + .5
        LOOP
    CLOSE fin%
    errorlevel = 0
LOOP

    OPEN "moneycab.mcb" FOR INPUT AS #fin%
        DO WHILE NOT EOF(fin%)
            INPUT #fin%, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung
                IF errorlevel THEN EXIT DO 'tritt auf, falls ein Zeilenvorschub dem MCB-File am Schluss angehngt ist...
            IF UCASE$(LEFT$(moneycab.Bezeichnung, 8)) <> "BERTRAG" AND UCASE$(LEFT$(moneycab.Bezeichnung, 8)) <> "BERTRAG" THEN WRITE #fout%, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung
            IF TIMER >= nz THEN TimeLock 1: nz = TIMER + .5
        LOOP
    CLOSE fin%

CLOSE f%, fout%
TimeLock 0


END SUB

SUB MakeWindow (a, B, c, d)

'Fenster:
LINE (a, B)-(c, d), Fensterfarbe, B
LINE (a + 2, B + 2)-(c - 1, d - 1), 0, BF
'Schatten:
LINE (a + 1, B + 1)-(c - 1, B + 1), Schattenfarbe
LINE (a + 1, B + 1)-(a + 1, d - 1), Schattenfarbe
'Rand:
LINE (c + 1, d + 1)-(a, d + 1), Randfarbe
LINE (c + 1, d + 1)-(c + 1, B), Randfarbe

TextScale = INT(B / 14) + 2 '=Zeile
TextBreak = INT(a / 8) + 2 '=Spalte


EBox.left = c - 31: EBox.top = d - 24
Left = INT(a / 8) + 2: Top = INT(B / 14) + 2: Right = INT((c + 8) / 8) - 1: Down = INT((d + 14) / 14) - 1

END SUB

SUB ManuelleBuchungen 'Zeigt eine Liste der manuellen Buchungen an

MakeTotallyList 1

Register 0, 0, 0, 0, "Statistiken - Liste manueller Buchungen"

errorlevel = 0
CLOSE 1
OPEN "mcb.tmp" FOR INPUT AS 1
IF errorlevel THEN Dialog "Buchungsdatei kann nicht geffnet werden.": EXIT SUB

ERASE Combo
Combo(1, 1) = "In dieser Ansicht sind keine Informationen verfgbar."

'Zeile aus Logbuch einlesen:
start% = 1
DO WHILE NOT EOF(1)
        INPUT #1, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung
        IF LEFT$(moneycab.Bezeichnung, 1) = "$" THEN Combo(1, start%) = moneycab.Datum + " " + Franken(moneycab.wert) + " (" + Produktwert(moneycab.lagerveraenderung) + ", " + moneycab.Produkt + "), " + moneycab.Bezeichnung: start% = start% + 1
LOOP

a$ = ComboBox(1, 5, 2, 23, 79)

END SUB

SUB Menuact (Menu$)
Zeilen = VAL(LEFT$(Menu$, 2))
Spalten = VAL(MID$(Menu$, 3, 2))
Caption$ = MID$(Menu$, 5)
a = Spalten * 8 - 11: B = Zeilen * 14 - 17
c = (Spalten + LEN(Caption$)) * 8 - 5: d = (Zeilen + 1) * 14 - 11


IF Activ = Menu$ THEN
LOCATE Zeilen, Spalten: PRINT Caption$
Schatten:
LINE (a + 1, B + 1)-(c - 1, B + 1), Schattenfarbe
LINE (a + 1, B + 1)-(a + 1, d - 1), Schattenfarbe
ELSE
LINE (a + 1, B + 1)-(c - 1, B + 1), 0
LINE (a + 1, B + 1)-(a + 1, d - 1), 0
END IF
END SUB

SUB MenuBox (Zeilen, Spalten, Caption$)
STATIC NMZeilen AS INTEGER, NMSpalten AS INTEGER
IF NMZeilen = 0 THEN NMZeilen = Top
IF NMSpalten = 0 THEN NMSpalten = Left
IF Zeilen = 0 THEN Zeilen = NMZeilen
IF Spalten = 0 THEN Spalten = NMSpalten

IF Spalten + LEN(Caption$) - 1 > Right THEN Spalten = Left: Zeilen = Zeilen + 2
IF Zeilen > Down THEN Zeilen = Top: Spalten = Left

a = Spalten * 8 - 11: B = Zeilen * 14 - 17: c = (Spalten + LEN(Caption$)) * 8 - 5
d = (Zeilen + 1) * 14 - 11

'Lschen:
LINE (a, B)-(c, d), 0, BF
LOCATE Zeilen, Spalten: PRINT Caption$
'Fenster:
LINE (a, B)-(c, d), Fensterfarbe, B
'Schatten:
'LINE (a + 1, B + 1)-(c - 1, B + 1), Schattenfarbe
'LINE (a + 1, B + 1)-(a + 1, d - 1), Schattenfarbe
'Rand:
LINE (c + 1, d + 1)-(a, d + 1), Randfarbe
LINE (c + 1, d + 1)-(c + 1, B), Randfarbe



NMSpalten = Spalten + LEN(Caption$) + 2
NMZeilen = Zeilen
IF NMSpalten > Right THEN NMSpalten = Left: NMZeilen = Zeilen + 2
IF NMZeilen > Down THEN NMZeilen = Top: NMSpalten = Left

'Menu eintragen:
Zeilen$ = MID$(STR$(Zeilen), 2)
Spalten$ = MID$(STR$(Spalten), 2)
IF LEN(Zeilen$) < 2 THEN Zeilen$ = "0" + Zeilen$
IF LEN(Spalten$) < 2 THEN Spalten$ = "0" + Spalten$

a$ = Zeilen$ + Spalten$ + Caption$
i = 0
DO: i = i + 1
IF MenuList(i) = a$ THEN EXIT SUB
LOOP UNTIL MenuList(i) = ""
MenuList(i) = a$
MenuNr = 1


TextScale = Zeilen + 2
END SUB

FUNCTION MenuInt$ (Item$, Trennzeichen$)

Item$ = Item$ + Trennzeichen$

i = 0
MaxLenth = 1
ERASE Combo

DO
i = i + 1

a$ = Trim(Item$, Trennzeichen$, i)

IF LEN(a$) > 77 THEN a$ = LEFT$(a$, 77)
IF LEN(a$) > MaxLenth THEN MaxLenth = LEN(a$)

IF a$ <> "" THEN Combo(1, i) = a$


LOOP WHILE a$ <> ""

Zeilen = VAL(LEFT$(MenuList(MenuNr), 2)) + 1
Spalten = VAL(MID$(MenuList(MenuNr), 3, 2))
IF Spalten + MaxLenth > 79 THEN Spalten = 79 - MaxLenth
IF Zeilen + i - 1 > 25 THEN Zeilen = 25 - i + 1
PCOPY 0, 1

a$ = ComboBox(1, Zeilen, Spalten, Zeilen + i - 2, Spalten + MaxLenth)


DO

SELECT CASE keyb
CASE CHR$(13): MenuInt$ = a$: EXIT DO
CASE "esc", "tab": EXIT DO
END SELECT
LOOP

PCOPY 1, 0
Activate CHR$(0)

END FUNCTION

SUB Monatsabschluss (fragen%)
IF fragen% THEN
    Register 4, 20, 16, 60, "Monatsabschluss"
    ExitBox -1, -1
    Echo ""
    Echo "Hiermit werden smtliche Buchungen archiviert. Nach dem Monatsabschluss knnen vergangene Buchungen nicht mehr storniert werden."
    Echo ""
    COLOR InfoColor
    Echo "Mchten Sie jetzt fortfahren?"
    COLOR Farbe
    a$ = InputBox(13, 22, "", 4, 1)
    IF a$ <> "ja" OR keyb = "esc" THEN EXIT SUB
END IF

filename$ = LEFT$(DATE$, 2) + MID$(DATE$, 4, 2) + RIGHT$(DATE$, 4) + ".mcb"
IF exist(filename$) THEN Dialog "Abbruch: Es wurde heute bereits einen Monatsabschluss durchgefhrt.": EXIT SUB
FileCopy "moneycab.mcb", filename$, "Buchungsdatenbank wird archiviert..."

CLOSE 1
OPEN filename$ FOR INPUT AS 1
IF errorlevel THEN Dialog "Der Monatsabschluss konnte nicht erfolgreich durchgefhrt werden. Kontaktieren Sie den Hersteller fr weiteren Support.": EXIT SUB

'Zeile aus Logbuch einlesen, um den zu bertragenden Bruttoerls auszurechnen:
totalwert = 0'Variable fr die zu errechnende Totalsumme
lager = 0
lagertotal = 0
ekeinlage = 0
DO WHILE NOT EOF(1)
        INPUT #1, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung
IF LTRIM$(Trim$(moneycab.Datum, CHR$(0), 1)) <> "" THEN
        totalwert = totalwert + moneycab.wert
        lager = lager + moneycab.lagerveraenderung
        IF LEFT$(moneycab.Bezeichnung, 12) = "Eigenkapital" THEN ekeinlage = ekeinlage + moneycab.wert
END IF
LOOP
CLOSE 1

OPEN "mcbmoa.rsc" FOR APPEND AS 1
PRINT #1, filename$
CLOSE 1

errorlevel = 0

DIM Produkte AS Produktedatenbank

f% = FREEFILE
OPEN "produkte.bnk" FOR RANDOM AS f% LEN = LEN(Produkte)
f2% = FREEFILE
OPEN "moneycab.tmp" FOR OUTPUT AS #f2%

i% = 0
DO
i% = i% + 1
GET f%, i%, Produkte
    IF Trim$(Produkte.Produkt, CHR$(0), 1) = "" THEN EXIT DO
    lagervomprodukt = GetLager(Produkte.Produkt)
    lagertotal = lagertotal + lagervomprodukt

IF lagervomprodukt <> 0 THEN
moneycab.Datum = SDate$(DATE$)
moneycab.wert = 0
moneycab.lagerveraenderung = lagervomprodukt
moneycab.Produkt = Produkte.Produkt
moneycab.Bezeichnung = "bertrag"

'Transaktion jetzt abspeichern:
        WRITE #f2%, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung
END IF

LOOP UNTIL Trim$(Produkte.Produkt, CHR$(0), 1) = ""
CLOSE f%

'Andere Produkte & bertrag von Bruttogewinn (referenzierend aus totalwert)
moneycab.Datum = SDate$(DATE$)
moneycab.wert = totalwert - ekeinlage
moneycab.lagerveraenderung = 0
moneycab.Produkt = "Anderes Produkt"
moneycab.Bezeichnung = "bertrag"

'Transaktion jetzt abspeichern:
        WRITE #f2%, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung

'berprfen, ob Lagerkorrektur notwendig: (unaufgefhrte Produkte) = Produkte, die nicht in der Sortimentsliste eingetragen sind...
IF lagertotal - lager <> 0 THEN
    moneycab.Datum = SDate$(DATE$)
    moneycab.wert = 0
    moneycab.lagerveraenderung = lager - lagertotal
    moneycab.Produkt = "Anderes Produkt"
    moneycab.Bezeichnung = "Lagerwertbertrag unaufgef. Produkte"

    'Transaktion jetzt abspeichern:
        WRITE #f2%, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung
END IF

'bertrag der Eigenkapitaleinlage
IF ekeinlage <> 0 THEN
moneycab.Datum = SDate$(DATE$)
moneycab.wert = ekeinlage
moneycab.lagerveraenderung = 0
moneycab.Produkt = "Anderes Produkt"
moneycab.Bezeichnung = "Eigenkapital bertrag"

'Transaktion jetzt abspeichern:
        WRITE #f2%, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung
END IF
CLOSE #f2%

IF errorlevel = 0 THEN
    KILL "moneycab.mcb"
    NAME "moneycab.tmp" AS "moneycab.mcb"
    Dialog "Der Monatsabschluss wurde durchgefhrt."
ELSE
    Dialog "Der Monatsabschluss konnte nicht erfolgreich durchgefhrt werden. Moneycab neustarten und erneut versuchen, oder wenden Sie sich an den Support."
    KILL filename$
END IF

END SUB

SUB NewBox (Name$) 'Richtet einen neuen Ordner ein.

CLOSE 1: OPEN "ORDNER.BNK" FOR RANDOM AS 1
i = 0
DO
i = i + 1
GET 1, i, a$
IF a$ = Name$ THEN BEEP: Dialog "Es wurde versucht, einen Ordner zu erstellen, welcher schon existiert.": errorlevel = 1: EXIT SUB
LOOP UNTIL a$ = ""

PUT 1, i, Name$
errorlevel = 0

END SUB

SUB NextControl
SELECT CASE ControlConnect
CASE 0
tC = 0
DO
tC = tC + 1
LOOP WHILE ControlList(tC) <> ""
tC = tC - 1

ControlNr = ControlNr + 1
IF ControlNr > tC THEN ControlNr = tC
i = 0
DO
i = i + 1
a$ = ControlList(i)
Activ = MID$(ControlList(ControlNr), 5)
Zeilen = VAL(MID$(a$, 1, 2))
Spalten = VAL(MID$(a$, 3, 2))
Texta$ = MID$(a$, 5)
IF a$ = "" THEN EXIT DO
Control Zeilen, Spalten, Texta$
LOOP UNTIL a$ = ""
CASE 1
tC = 0: DO: tC = tC + 1: LOOP WHILE MenuList(tC) <> ""
MenuNr = MenuNr + 1
IF MenuNr > tC - 1 THEN MenuNr = tC - 1
Activate MenuList(MenuNr)
CASE 2
tC = 0
DO
tC = tC + 1
LOOP WHILE Symbollist(tC) <> ""
SymbolNr = SymbolNr + 1: Symb.pnr = Symb.pnr + 1

IF SymbolNr > tC - 1 THEN
SymbolNr = tC - 1: Symb.pnr = Symb.pnr - 1
ELSE
IF Symb.pnr > Symb.count THEN
DimNow = 1
SymbolNr = SymbolNr - 1: Symb.pnr = Symb.pnr - 1
LINE (Left * 8 - 8, Top * 14 - 14)-(Right * 8, Down * 14), 0, BF
ShowSymbols
END IF
END IF
Activate Symbollist(SymbolNr)
END SELECT
END SUB

SUB PartFormat (Text$, Setting$)

IF INSTR(Text$, CHR$(0)) THEN
    Setting$ = MID$(Text$, INSTR(Text$, CHR$(0)) + 1)
    Text$ = LEFT$(Text$, INSTR(Text$, CHR$(0)) - 1)
ELSE
    Setting$ = ""
END IF

END SUB

FUNCTION PasswordOk% 'Passwordeingabedialog

             Register 8, 36, 12, 75, "Benutzerpasswort eingeben:"
              a$ = InputBox$(10, 38, CHR$(0), 29, 1)
              f% = FREEFILE
              OPEN "mcbuser.pwd" FOR BINARY AS f%
                GET f%, 1, checksum
                ok% = GetValidPassword(checksum, a$)
                CLOSE f%
                IF NOT ok% THEN Dialog "Passwort nicht korrekt."
                PasswordOk% = ok%

END FUNCTION

SUB PieSliece (a%, B%, Radius, StartPz, EndePz, Titel$, col%, randcol%)
'Zeichnet ein Kuchenstck. (Kuchendiagramm)
'StartPz gibt die Prozentzahl des Starts an, EndePz die des Endes

asp = .85

CIRCLE (a%, B%), Radius, randcol%, , , asp


w1 = StartPz * 3.6

    x1 = Radius * Sinus(w1) + a%
    y1 = (Radius * CoSinus(w1)) * asp + B%

LINE (x1, y1)-(a%, B%), randcol%

w2 = EndePz * 3.6

    x2 = Radius * Sinus(w2) + a%
    y2 = (Radius * CoSinus(w2)) * asp + B%

LINE (x2, y2)-(a%, B%), randcol%

w2 = (((EndePz - StartPz) / 2) * 360 / 100) + w1

    x2 = (Radius / 2) * Sinus(w2) + a%
    y2 = ((Radius / 2) * CoSinus(w2)) * asp + B%

PAINT (x2, y2), col%, randcol%

IF x2 > a% THEN xp% = 1 ELSE xp% = 0
IF y2 > B% THEN yp% = 1 ELSE yp% = 0

    x2 = ((Radius + 8) * Sinus(w2) + a%) / 8 + xp%
    y2 = (((Radius + 14) * CoSinus(w2)) * asp + B%) / 14 + yp%

TextBreak = x2
TextScale = y2
LOCATE y2, x2

IF xp% = 0 THEN
    ar% = Right
    Right = x2
    TextBreak = Left
    Echo Titel$ + Format("r")
    Right = ar%
ELSE
    Echo Titel$ + Format("l")
END IF

END SUB

FUNCTION positiv (wert) 'die zurckgegebene Zahl ist immer positiv
    IF wert < 0 THEN a = wert * -1 ELSE a = wert
    positiv = a
END FUNCTION

SUB ProdukteLager

ClearControls 3

ERASE Combo
Register 8, 20, 16, 60, "Lagerbestnde berechnen"
Echo ""
Echo "Bitte warten Sie, whrend die Lagerbestnde erfasst werden..."
Register 0, 0, 0, 0, "Statistiken - Lagerbestnde"
ExitBox -1, -1


f% = 255
i = 0
DIM Produkte AS Produktedatenbank
CLOSE f%
OPEN "produkte.bnk" FOR RANDOM AS f% LEN = LEN(Produkte)

DO
GET f%, , Produkte
IF Trim$(Produkte.Produkt, CHR$(0), 1) = "" THEN EXIT DO
pref$ = ""
IF LEFT$(Produkte.Beschreibung, 1) = "#" THEN pref$ = CHR$(0)
lager = GetLager(Produkte.Produkt)
IF pref$ = "" OR lager <> 0 THEN i = i + 1: Combo(1, i) = pref$ + Produkte.Produkt + " " + Produktwert(lager) + " Stck an Lager; EP: " + LTRIM$(Produkte.EP) + " / VP: " + LTRIM$(Produkte.VP)
LOOP UNTIL Trim$(Produkte.Produkt, CHR$(0), 1) = ""

a$ = ComboBox(1, 4, 4, 23, 70)

CLOSE f%

END SUB

FUNCTION Produktwert$ (wert) 'print using-hnliche Funktion
w$ = RTRIM$(LTRIM$(STR$(wert)))

'richtiges Formatieren:
IF wert > 0 THEN w$ = "+" + w$

errorlevel = 0
Produktwert$ = SPACE$(7 - LEN(w$)) + w$
IF errorlevel THEN Produktwert$ = "xxxx"

END FUNCTION

SUB ProgressBar (Stat AS INTEGER)

IF Stat > 100 THEN Stat = 100

LINE (179, 174)-(459, 194), Farbe, B

x = 278 * Stat / 100

LINE (180, 175)-(180 + x, 193), InfoColor, BF

END SUB

SUB Register (z, s, zu, su, Text$)
IF z = 0 THEN z = 1
IF s = 0 THEN s = 1
IF zu = 0 THEN zu = 25
IF su = 0 THEN su = 80
IF s + LEN(Text$) > su - 1 AND su - s > 2 THEN Text$ = LEFT$(Text$, su - s - 3) + ".."
a = s * 8 - 4
B = z * 14 - 9
c = su * 8 - 7
d = zu * 14 - 7
'Fenster:
LINE (a, B - 4)-(c, d), 0, BF
LINE (a, B)-(c, d), Fensterfarbe, B
'Schatten:
LINE (a + 1, B + 1)-(c - 1, B + 1), Schattenfarbe
LINE (a + 1, B + 1)-(a + 1, d - 1), Schattenfarbe
'Rand:
LINE (c + 1, d + 1)-(a, d + 1), Randfarbe
LINE (c + 1, d + 1)-(c + 1, B), Randfarbe


TextScale = INT(B / 14) + 2 '=Zeile
TextBreak = INT(a / 8) + 2 '=Spalte
LOCATE INT(B / 14) + 1, TextBreak
PRINT Text$
Break = su - 1
IF z = 1 THEN LINE (0, 0)-(638, 0), Fensterfarbe: LINE (1, 1)-(637, 1), 0: LINE (1, 1)-(1, 347), 0
EBox.left = c - 31: EBox.top = d - 24
Left = s + 1: Top = z + 1: Right = su - 1: Down = zu - 1
END SUB

FUNCTION SDate$ (Datum$) 'Function fr das Systemdatum
SELECT CASE Datumsformat
CASE 0'TT.MM.JJJJ
SDate$ = MID$(Datum$, 4, 2) + "." + LEFT$(Datum$, 2) + "." + RIGHT$(Datum$, 4)
CASE 1'MM-TT-JJJJ
SDate$ = Datum$
CASE 2'JJJJ/MM/TT
SDate$ = RIGHT$(Datum$, 4) + "/" + LEFT$(Datum$, 2) + "/" + MID$(Datum$, 4, 2)
END SELECT
END FUNCTION

SUB SetAttr (aDatei$, Attr$)
Datei$ = aDatei$'ByVal simulieren

IF RIGHT$(Datei$, 4) = ".lao" THEN Datei$ = LEFT$(Datei$, LEN(Datei$) - 4)
nf = FREEFILE

CLOSE nf: OPEN "DATEIEN.BNK" FOR RANDOM AS #nf LEN = 400
FIELD nf, 11 AS Dateiname$, 16 AS Art$, 11 AS Symbol$, 32 AS OsName$, 32 AS Ordner$, 11 AS link$, 10 AS Datum$, 5 AS Zeit$, 1 AS Attribut$, 256 AS FileInfo$
a = 0
DO
a = a + 1
GET nf, a
IF RTRIM$(Dateiname$) = Datei$ THEN LSET Attribut$ = Attr$: PUT nf, a: EXIT SUB
LOOP UNTIL Dateiname$ = STRING$(11, 0)

END SUB

SUB SetTexts (start%, Txt$, weiter%)
PartFormat Txt$, fmt$

'Format: "l", "c", "r": Linksbndig, zentriert, rechtsbndig

SELECT CASE fmt$
    CASE "l", "": Align% = 0
    CASE "c": Align% = 1
    CASE "r": Align% = 2
END SELECT

Text$ = Txt$ + " "
weiter% = start%

DIM s AS INTEGER, z AS INTEGER, t AS INTEGER, brk AS INTEGER


s = 1
z = 78'Right - TextBreak + 2'Zeilenlnge
dwn = 0

p1% = s
p2% = p1%
DO
    t = t + 1
        IF t = p1% THEN p2% = p1%'alten Retten
        p1% = INSTR(t, Text$, " ")
        IF p1% = 0 OR p1% = LEN(Text$) THEN
            IF p1% <= s + z - 1 THEN p2% = LEN(Text$): brk = -1
        END IF

        IF p1% > s + z - 1 OR brk THEN 'nehme alten, weil neuen ber die Zeile ragt.
            'Zeile ausgeben:
            p1% = p2%
            IF TextScale + dwn > Down THEN EXIT DO
                IF p1% - s <= 0 THEN 'falls Wort zu lange (nicht in die Zeile passt:)

                    p1% = s + z - 1
                    a$ = MID$(Text$, s, p1% - s)
                    t = p1% - 1
                    s = t + 1

                ELSE

                    a$ = MID$(Text$, s, p1% - s)
                    t = p1% + 1
                    s = t
                END IF

            'Ausrichtung:
            SELECT CASE Align%
                CASE 0: x% = 0
                CASE 1: x% = FIX((Right - TextBreak - LEN(a$) + 1) / 2)
                CASE 2: x% = z - LEN(a$) + 1
            END SELECT

            'LOCATE TextScale + dwn, x%
            a$ = SPACE$(x%) + a$
            Texts(weiter%) = a$
            weiter% = weiter% + 1

            dwn = dwn + 1
        END IF
LOOP UNTIL t >= LEN(Text$)


END SUB

SUB ShowPicture (PNr, Streck)

Bild$ = Pictures(PNr)
IF Streck = 0 THEN Streck = 1

DIM Befehle(2500, 5) AS SINGLE
DIM i AS INTEGER
DIM Nr AS INTEGER

CLOSE 1: OPEN Bild$ FOR BINARY AS 1

i = 0
DO
i = i + 1
FOR Nr = 0 TO 5
GET 1, , Befehle(i, Nr)
NEXT
LOOP WHILE Befehle(i, 0) <> 0
i = 0
DO
i = i + 1
SELECT CASE CHR$(Befehle(i, 0))
CASE "p": PSET (Befehle(i, 1) + xplus, Befehle(i, 2) + yplus), Befehle(i, 3)
CASE "m": PAINT (Befehle(i, 1) + xplus, Befehle(i, 2) + yplus), Befehle(i, 3), Befehle(i, 4)
CASE "l": LINE (Befehle(i, 1) + xplus, Befehle(i, 2) + yplus)-(Befehle(i, 3) + xplus, Befehle(i, 4) + yplus), Befehle(i, 5)
CASE "r": LINE (Befehle(i, 1) + xplus, Befehle(i, 2) + yplus)-(Befehle(i, 3) + xplus, Befehle(i, 4) + yplus), Befehle(i, 5), B
CASE "b": LINE (Befehle(i, 1) + xplus, Befehle(i, 2) + yplus)-(Befehle(i, 3) + xplus, Befehle(i, 4) + yplus), Befehle(i, 5), BF
CASE "k": CIRCLE (Befehle(i, 1) + xplus, Befehle(i, 2) + yplus), Befehle(i, 3), Befehle(i, 4), , , Befehle(i, 5)
CASE "x": CIRCLE (Befehle(i, 1) + xplus, Befehle(i, 2) + yplus), Befehle(i, 3), Befehle(i, 4), Befehle(i + 1, 1), Befehle(i + 1, 2), Befehle(i, 5)
          i = i + 1
END SELECT
LOOP WHILE Befehle(i, 0) <> 0
i = 0

END SUB

SUB ShowSymbols
Symb.count = 0
Symbol = SymbolNr
DIM Befehle(2500, 5) AS SINGLE
DIM i AS INTEGER
DIM Nr AS INTEGER
DIM LastSymbol AS STRING


IF Symbol = 0 THEN DimY = 0

DO
Symbol = Symbol + 1
Symb.count = Symb.count + 1

a$ = Symbollist(Symbol)
IF a$ = "" THEN EXIT DO

Name$ = MID$(a$, 7, 8)
Kennung$ = MID$(a$, 15)
IF LEN(Kennung$) < 4 THEN Kennung$ = STRING$(INT((4 - LEN(Kennung$)) / 2), " ") + Kennung$ + STRING$(CINT((4 - LEN(Kennung$)) / 2 + .1), " ")

x = VAL(LEFT$(a$, 3))
y = VAL(MID$(a$, 4, 3))
IF DimNow = 1 THEN DimY = y - Top * 14: DimNow = 0
y = y - DimY
IF y > Down * 14 - 46 THEN DimNow = 1: EXIT DO'DimY = DimY + y - Top * 14: EXIT DO

VIEW (x, y)-(x + 40, y + 40), SymbolColor, SymbolFrame
Spalten = (INT(x / 8)) + 4 - CINT(LEN(Kennung$) / 2)
IF Spalten <= 1 THEN Spalten = 2
IF Spalten + LEN(Kennung$) > Right THEN Spalten = Right - LEN(Kennung$)
IF Spalten <= Left THEN Kennung$ = LEFT$(Kennung$, LEN(Kennung$) - ((Left - Spalten) + 1)): Spalten = Left + 1
LOCATE INT((y + 40) / 14) + 2, Spalten: PRINT Kennung$
Symb.left = Spalten + LEN(Kennung$)

IF LastSymbol <> Name$ THEN
LastSymbol = Name$

CLOSE 1: OPEN Name$ + ".lsb" FOR BINARY AS 1: GET 1, 1, TA
IF TA = 0 THEN
    Name$ = Name$
    CLOSE 1: OPEN RTRIM$(Name$) + ".lsb" FOR BINARY AS 1: GET 1, 1, TA
    IF TA = 0 THEN Name$ = "c:\laos\sys"
END IF

CLOSE 1: OPEN Name$ + ".lsb" FOR BINARY AS 1

i = 0
DO
i = i + 1
FOR Nr = 0 TO 5
GET 1, , Befehle(i, Nr)
NEXT
LOOP WHILE Befehle(i, 0) <> 0

i = 0
DO
i = i + 1
SELECT CASE CHR$(Befehle(i, 0))
CASE "p": PSET (Befehle(i, 1) + xplus, Befehle(i, 2) + yplus), Befehle(i, 3)
CASE "m": PAINT (Befehle(i, 1) + xplus, Befehle(i, 2) + yplus), Befehle(i, 3), Befehle(i, 4)
CASE "l": LINE (Befehle(i, 1) + xplus, Befehle(i, 2) + yplus)-(Befehle(i, 3) + xplus, Befehle(i, 4) + yplus), Befehle(i, 5)
CASE "r": LINE (Befehle(i, 1) + xplus, Befehle(i, 2) + yplus)-(Befehle(i, 3) + xplus, Befehle(i, 4) + yplus), Befehle(i, 5), B
CASE "b": LINE (Befehle(i, 1) + xplus, Befehle(i, 2) + yplus)-(Befehle(i, 3) + xplus, Befehle(i, 4) + yplus), Befehle(i, 5), BF
CASE "k": CIRCLE (Befehle(i, 1) + xplus, Befehle(i, 2) + yplus), Befehle(i, 3), Befehle(i, 4), , , Befehle(i, 5)
CASE "x": CIRCLE (Befehle(i, 1) + xplus, Befehle(i, 2) + yplus), Befehle(i, 3), Befehle(i, 4), Befehle(i + 1, 1), Befehle(i + 1, 2), Befehle(i, 5)
          i = i + 1
END SELECT
LOOP WHILE Befehle(i, 0) <> 0
i = 0
    GET (0, 0)-(40, 40), Hintergrund
ELSE
    PUT (0, 0), Hintergrund, PSET
END IF

VIEW 'Setzt das Darstellungsfeld wieder auf den ganzen Bildschirm.
LOOP
IF a$ <> "" THEN Symb.ipp = Symb.count - 1
Symb.total = Symbol - 1
Symb.count = Symb.count - 1

ControlConnect = 2 'Setzt den Verweis auf das Symbol-Steuerelement
SymbolNr = Symb.total - Symb.count + 1
Symb.pnr = 1
END SUB

FUNCTION Sinus (Winkel)
    Sinus = SIN(Winkel * (PI / 180))
END FUNCTION

SUB Statistiken
MakeTotallyList 0
IF keyb = "esc" THEN EXIT SUB

7011
Register 0, 0, 0, 0, "moneycab Statistiken " + glblstatus$
ExitBox -1, -1

ERASE Combo

Combo(1, 1) = "Umsatz nach Standorten"
Combo(1, 2) = "Verkauf nach Produkten"
Combo(1, 3) = "Umsatzverlauf"
Combo(1, 4) = "Bruttogewinnstatistik"
Combo(1, 5) = "-"
Combo(1, 6) = "Lagerbestnde"
Combo(1, 7) = "Verlauf Lagerbestand"
Combo(1, 8) = "-"
Combo(1, 9) = "Detaillierte Zusammenfassung"
Combo(1, 10) = "Monatsjournal"
Combo(1, 11) = "Liste manueller Buchungen"
Combo(1, 12) = "Eigenbedarf & Diebsthle"
Combo(1, 13) = "-"
Combo(1, 14) = "Zurck"

a$ = ComboBox(1, 7, 5, 20, 75)
ActivItem = a$
IF keyb = "esc" OR a$ = "Zurck" THEN EXIT SUB
col% = 0

SELECT CASE choice
    CASE 7
Register 0, 0, 0, 0, "Verlauf Lagerbestand summiert"
ExitBox -1, -1

nz = TIMER + .5
TimeLock 1
                lagerwert = 0
                CLOSE 1
                errorlevel = 0
                OPEN "mcb.tmp" FOR INPUT AS 1
                f% = FREEFILE
                OPEN "graph.tmp" FOR OUTPUT AS f%
                IF errorlevel THEN Dialog "Die Buchungsdatei kann nicht geffnet werden. Es kann keine Statistik berechnet werden.": EXIT SUB
                DO WHILE NOT EOF(1)
                    INPUT #1, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung
                        lagerwert = lagerwert + moneycab.lagerveraenderung
                        WRITE #f%, LEFT$(moneycab.Datum, 5), lagerwert
                    IF TIMER > nz THEN nz = TIMER + .5: TimeLock 1
                LOOP
                CLOSE 1, f%
                TimeLock 0

                Graph 100, 21, 620, 287, "graph.tmp", 0
LOCATE 24, 3: PRINT "Aktueller Lagerbestand: "; lagerwert;
GetInp


    CASE 4
        MakeTotallyList 1
Register 0, 0, 0, 0, "Bruttogewinnstatistik"
ExitBox -1, -1

nz = TIMER + .5
TimeLock 1
                totalwert = 0
                CLOSE 1
                errorlevel = 0
                OPEN "mcb.tmp" FOR INPUT AS 1
                f% = FREEFILE
                OPEN "graph.tmp" FOR OUTPUT AS f%
                IF errorlevel THEN Dialog "Die Buchungsdatei kann nicht geffnet werden. Es kann keine Statistik berechnet werden.": EXIT SUB
                DO WHILE NOT EOF(1)
                    INPUT #1, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung
                    totalwert = totalwert + moneycab.wert
                    WRITE #f%, LEFT$(moneycab.Datum, 5), totalwert
                    IF TIMER > nz THEN nz = TIMER + .5: TimeLock 1
                LOOP
                CLOSE 1, f%
                TimeLock 0

                Graph 100, 21, 620, 287, "graph.tmp", 1
LOCATE 24, 3: PRINT "Aktueller Bruttogewinn: "; LTRIM$(Franken(totalwert));
GetInp

    CASE 3
        MakeTotallyList 1
Register 0, 0, 0, 0, "Umsatzverlauf"
ExitBox -1, -1

nz = TIMER + .5
TimeLock 1
                totalwert = 0
                CLOSE 1
                errorlevel = 0
                OPEN "mcb.tmp" FOR INPUT AS 1
                f% = FREEFILE
                OPEN "graph.tmp" FOR OUTPUT AS f%
                IF errorlevel THEN Dialog "Die Buchungsdatei kann nicht geffnet werden. Es kann keine Statistik berechnet werden.": EXIT SUB
                DO WHILE NOT EOF(1)
                    INPUT #1, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung
                    IF LEFT$(moneycab.Bezeichnung, 7) = "Verkauf" THEN
                        totalwert = totalwert + moneycab.wert
                        WRITE #f%, LEFT$(moneycab.Datum, 5), totalwert
                    END IF
                    IF TIMER > nz THEN nz = TIMER + .5: TimeLock 1
                LOOP
                CLOSE 1, f%
                TimeLock 0

                Graph 100, 21, 620, 287, "graph.tmp", 1
GetInp

    CASE 12
        MakeTotallyList 1

Register 0, 0, 0, 0, "Eigenbedarf & Diebsthle"

ERASE Texts
start% = 1

TimeLock 1
CreateDetail "Eigenbedarf", "Bestandeskorrektur Eigenbedarf", start%
TimeLock 1
CreateDetail "Diebsthle", "Bestandeskorrektur Diebstahl", start%
TimeLock 0

NoChanges = -1
EditBox 4, 2, 23, 79
NoChanges = 0

    CASE 9
        MakeTotallyList 1
        BesonderesList
    CASE 10: ListeKontobuch
    CASE 11: ManuelleBuchungen
    CASE 6: ProdukteLager
    CASE 2
        MakeTotallyList 1
        Register 0, 0, 0, 0, "Statistiken - Verkauf nach Produkten"
        letzter = 0
                'total zuerst ausrechnen:
                totalwert = 0
                CLOSE 1
                errorlevel = 0
                OPEN "mcb.tmp" FOR INPUT AS 1
                IF errorlevel THEN Dialog "Die Buchungsdatei kann nicht geffnet werden. Es kann keine Statistik berechnet werden.": EXIT SUB
                DO WHILE NOT EOF(1)
                    INPUT #1, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung
                    IF LEFT$(moneycab.Bezeichnung, 7) = "Verkauf" THEN
                        totalwert = totalwert + moneycab.wert
                        totallager = totallager + moneycab.lagerveraenderung
                    END IF
                LOOP
                CLOSE 1

                DIM Produkte AS Produktedatenbank
                OPEN "produkte.bnk" FOR RANDOM AS 1 LEN = LEN(Produkte)
                i% = 0
                DO
                    i% = i% + 1
                    GET 1, i%, Produkte
                    IF Trim$(Produkte.Produkt, CHR$(0), 1) = "" THEN EXIT DO

7008
                wert = 0
                lager = 0
                f% = FREEFILE
                OPEN "mcb.tmp" FOR INPUT AS f%

                DO WHILE NOT EOF(f%)
                    INPUT #f%, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung
                    IF RTRIM$(moneycab.Produkt) = RTRIM$(Produkte.Produkt) AND LEFT$(moneycab.Bezeichnung, 7) = "Verkauf" THEN
                        wert = wert + moneycab.wert
                        lager = lager + moneycab.lagerveraenderung
                    END IF
                LOOP

                CLOSE f%
                    IF wert > 0 THEN
                        col% = col% + 1
                        IF col% > 14 THEN col% = 1
                        PieSliece 319, 174, 150, letzter, letzter + (wert * 100 / totalwert), RTRIM$(Produkte.Produkt) + " CHF " + LTRIM$(Franken(wert)), col%, 15
                        letzter = letzter + (wert * 100 / totalwert)
                    END IF
'                    IF RTRIM$(Produkte.Produkt) = "Anderes Prod" THEN GOTO 7009
                LOOP

                CLOSE 1
'                Produkte.Produkt = "Anderes Prod"
'                GOTO 7008
7009

col% = col% + 1
IF col% > 14 THEN col% = 1
IF letzter < 100 THEN PieSliece 319, 174, 150, letzter, 100, "Unerfasste Produkte CHF " + LTRIM$(Franken(CINT(totalwert - (letzter * totalwert) / 100))), col%, 15

LOCATE 24, 3: PRINT "Umsatz Total: "; LTRIM$(Franken(totalwert));
a$ = Getkey

   
    CASE 1
        MakeTotallyList 1
        Register 0, 0, 0, 0, "Statistiken - Umsatz nach Standorten"
        
        letzter = 0
                'total zuerst ausrechnen:
                totalwert = 0
                CLOSE 1
                errorlevel = 0
                OPEN "mcb.tmp" FOR INPUT AS 1
                IF errorlevel THEN Dialog "Die Buchungsdatei kann nicht geffnet werden. Es kann keine Statistik berechnet werden.": EXIT SUB
                DO WHILE NOT EOF(1)
                    INPUT #1, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung
                    IF LEFT$(moneycab.Bezeichnung, 7) = "Verkauf" THEN
                        totalwert = totalwert + moneycab.wert
                        totallager = totallager + moneycab.lagerveraenderung
                    END IF
                LOOP
                CLOSE 1

                OPEN "saledest.bnk" FOR INPUT AS #1
                i% = 1
                IF errorlevel THEN Dialog "Es sind keine Standorte definiert die ausgewertet werden knnten.": GOTO 7011

                DO WHILE NOT EOF(1)
                        LINE INPUT #1, standort$

7012
                wert = 0
                lager = 0
                f% = FREEFILE
                OPEN "mcb.tmp" FOR INPUT AS f%


                DO WHILE NOT EOF(f%)
                    INPUT #f%, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung
                    IF RTRIM$(moneycab.Bezeichnung) = "Verkauf " + standort$ THEN
                        wert = wert + moneycab.wert
                        lager = lager + moneycab.lagerveraenderung
                    END IF
                LOOP

                CLOSE f%
                    IF wert > 0 THEN
                        col% = col% + 1
                        IF col% > 14 THEN col% = 1
                        PieSliece 319, 174, 150, letzter, letzter + (wert * 100 / totalwert), standort$ + " CHF " + LTRIM$(Franken(wert)), col%, 15
                        letzter = letzter + (wert * 100 / totalwert)
                    END IF
                    IF standort$ = "intern" THEN GOTO 7013
                LOOP

                CLOSE 1
                standort$ = "intern"
                GOTO 7012
7013

col% = col% + 1
IF col% > 14 THEN col% = 1
IF letzter < 100 THEN PieSliece 319, 174, 150, letzter, 100, "Verkauf auf Kredit CHF " + Franken(CINT(totalwert - (letzter * totalwert) / 100)), col%, 15

LOCATE 24, 3: PRINT "Umsatz Total: "; LTRIM$(Franken(totalwert));
a$ = Getkey

END SELECT

    GOTO 7011

END SUB

SUB StoppUhrBeep (Uhr)
STATIC progress AS INTEGER, totalwert, lager, bruttogewinn, Produkte AS Produktedatenbank, infotext$, ekeinlage, umsatz, msgshowed, i AS INTEGER, strDatum AS STRING, moadlgshowed AS INTEGER

SELECT CASE Uhr
CASE 1: TimeLock (1)
CASE 2: SCREEN , , 1, 1: COLOR , 0: CLS
    nz = TIMER + 300
a$ = "": DO: a$ = INKEY$: LOOP WHILE a$ = ""
SCREEN , , 0, 0: COLOR Farbe, Hintergrundfarbe
IF TIMER >= nz THEN
PCOPY 0, 1
    DO
        IF PasswordOk THEN
           'Passwort-Timeout neu setzen:
                file% = FREEFILE
                        OPEN "timeout.tmp" FOR OUTPUT AS file%
                        WRITE #file%, DATE$
                        WRITE #file%, TIMER + 1200 'Anzahl Sekunden, die verstreichen, bis das Passwort neu abgefragt wird.
                CLOSE #file%
            EXIT DO
        END IF
        IF keyb = "esc" THEN RUN "c:\laos\run.bas": SYSTEM
    LOOP
PCOPY 1, 0
END IF

CASE 3 'Ausrechnen der Zusammenfassung (Bruttoerls, Gewinnprognose, Lagerbestand...)

SELECT CASE progress
CASE 0
    infotext$ = ""

    errorlevel = 0
    CLOSE 1
    OPEN "moneycab.mcb" FOR INPUT AS 1
        IF errorlevel THEN progress = 2: EXIT SUB

    totalwert = 0'Variable fr die zu errechnende Totalsumme
    lager = 0
    ekeinlage = 0
    umsatz = 0
    i = 0
    progress = 1: EXIT SUB

CASE 1
'Zeile aus Logbuch einlesen:
nz = TIMER + .02
DO WHILE NOT EOF(1)
        INPUT #1, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung
        strDatum = moneycab.Datum
        totalwert = totalwert + moneycab.wert
        lager = lager + moneycab.lagerveraenderung
        IF LEFT$(moneycab.Bezeichnung, 12) = "Eigenkapital" THEN ekeinlage = ekeinlage + moneycab.wert
        IF LCASE$(LEFT$(moneycab.Bezeichnung, 7)) = "verkauf" THEN umsatz = umsatz + moneycab.wert
        i = i + 1
        IF TIMER >= nz THEN EXIT SUB
LOOP
LOCATE 17, 8
PRINT "Bruttoerls:   ";
IF totalwert < 0 THEN COLOR 12
PRINT Franken(totalwert)
bruttogewinn = totalwert
LOCATE 19, 8
COLOR Farbe
PRINT "Lagerbest. Summe: ";
IF lager < 0 THEN COLOR 12
PRINT Produktwert(lager)
COLOR Farbe
AnzBuchungen = i
progress = 2

CASE 2
'Gewinnprognose ausrechnen:

errorlevel = 0
CLOSE 1
OPEN "produkte.bnk" FOR RANDOM AS 1 LEN = LEN(Produkte)
    IF errorlevel THEN progress = 0: StoppUhr(3) = 0
    totalwert = 0
    lager = 0
    i = 0
    progress = 3

CASE 3
nz = TIMER + .02
DO
i = i + 1
GET 1, i, Produkte
IF Trim$(Produkte.Produkt, CHR$(0), 1) = "" THEN EXIT DO
    lag = GetLager(Produkte.Produkt)
    totalwert = totalwert + (lag * VAL(Produkte.VP))'Lagerwert VP
    lager = lager + (lag * VAL(Produkte.EP))'lagerwert ep
    IF VAL(Produkte.EP) = 0 OR VAL(Produkte.VP) = 0 THEN infotext$ = "Nicht alle EP bezw. VP sind in der Produktedatenbank definiert. Die entsprechenden Anzeigen sowie die Gewinnprognose sind unreferenzierbar."
IF TIMER >= nz THEN EXIT SUB
LOOP UNTIL Trim$(Produkte.Produkt, CHR$(0), 1) = ""

i = 0
LOCATE 17, 44
PRINT "Lagerwert VP:   ";
IF totalwert < 0 THEN COLOR 12
PRINT Franken(totalwert)
LOCATE 19, 44
COLOR Farbe
PRINT "Lagerwert EP:   ";
IF lager < 0 THEN COLOR 12
PRINT Franken(lager)
COLOR Farbe

LOCATE 21, 44
COLOR Farbe
PRINT "Gewinnprognose: ";
a = totalwert + bruttogewinn - ekeinlage
IF a < 0 THEN COLOR 12
PRINT Franken(a)

LOCATE 21, 8
PRINT "Monatsumsatz:  "; Franken(umsatz)
'IF ekeinlage < 0 THEN
'    COLOR 12
'    PRINT "EK Ausschuss: "; Franken(ekeinlage * -1)
'ELSE
'    COLOR Farbe
'    PRINT "Eigenkapital: "; Franken(ekeinlage)
'END IF

COLOR Farbe

StoppUhr(3) = 0: progress = 0
IF infotext$ <> "" AND NOT msgshowed THEN Dialog infotext$: msgshowed = -1

    IF MID$(strDatum, 4, 2) <> LEFT$(DATE$, 2) AND NOT moadlgshowed THEN
        moadlgshowed = -1
        PCOPY 0, 1
        ClearControls 0
        Register 8, 8, 16, 48, "Monatswechsel"
            ExitBox -1, -1
            Echo ""
            Echo "Achtung! Ein neuer Monat hat begonnen! Sie sollten einen Monatsabschluss durchfhren!"
                Control 14, 10, "Jetzt durchfhren"
                Control 14, 30, "Spter..."
            GetInp
            IF ControlNr = 1 AND keyb = CHR$(13) THEN Monatsabschluss -1
            ClearControls 0
            CLW
            PCOPY 1, 0

    END IF

END SELECT

CASE 5
    progress = 0
    StoppUhr(3) = 0
    i = 0
    CLOSE 1

END SELECT
END SUB

SUB Symbact (Symbol$) 'Aktiviert ein Symbol
x = VAL(MID$(Symbol$, 1, 3))
y = VAL(MID$(Symbol$, 4, 3))
IF DimNow = 1 THEN DimY = DimY + (y - Top * 14): DimNow = 0
y = y - DimY

IF Activ = Symbol$ THEN
LINE (x - 2, y - 2)-(x + 42, y + 42), Symbolactiv, B, SymbactStil
ELSE
IF y >= Top * 14 AND y < Down * 14 - 46 THEN LINE (x - 2, y - 2)-(x + 42, y + 42), 0, B, SymbactStil
END IF
END SUB

SUB TextBox (Zeilen, Spalten, Text$, Break)
'Break heisst hier: Hier wird der Text gebrochen (Zeilenumbruch)

IF TextScale = 0 THEN TextScale = Top
IF TextBreak = 0 THEN TextBreak = Left
IF Zeilen = 0 THEN Zeilen = TextScale
IF Spalten = 0 THEN Spalten = TextBreak + 1

IF Zeilen > 24 THEN Zeilen = 24

IF Spalten + LEN(Text$) > Right AND Break = 0 THEN Break = Right - Spalten
IF Break = 0 THEN Break = LEN(Text$)
IF Break = 0 THEN Spalten = Spalten - 1: Break = 1


a = Spalten * 8 - 11
B = Zeilen * 14 - 17
EndSpalte = Spalten + Break
EndZeile = Zeilen + INT(LEN(Text$) / Break + 1)
IF Break = LEN(Text$) THEN EndZeile = EndZeile - 1
c = EndSpalte * 8 - 5
d = EndZeile * 14 - 11

FrameWindow a, B, c, d, 1

ecr = Break * -1 + 1
FOR i = 1 TO INT(LEN(Text$) / Break) + 1
LOCATE Zeilen + i - 1, Spalten
ecr = ecr + Break
PRINT MID$(Text$, ecr, Break)
NEXT i
ecr = 0


TextScale = EndZeile + 1
END SUB

SUB TimeLock (status)
STATIC On.too
STATIC tm
Radius = 14 * 2
Farbe1 = 12
Farbe2 = 9
x = 319 - Radius
y = 174 - Radius

SELECT CASE status
CASE 1:
'Falls es das erste Mal ist, muss der Hintergrund noch gespeichert werden:
IF On.too = 0 THEN On.too = 1: GET (319 - Radius, 174 - Radius)-(319 + Radius, 174 + Radius), Hintergrund

LINE (x + Radius - Radius, y + Radius - Radius)-(x + Radius + Radius, y + Radius + Radius), 0, BF
IF tm = 1 THEN tm = 0 ELSE tm = 1

IF tm = 0 THEN
LINE (x + Radius / 3 * 2, y + Radius / 3 * 2)-(x + Radius / 3 * 4, y + Radius / 3 * 4), Farbe1
LINE (x + Radius / 3 * 2, y + Radius / 3 * 4)-(x + Radius / 3 * 4, y + Radius / 3 * 2), Farbe1
CIRCLE (x + Radius, y + Radius), Radius / 2, Farbe1, , , .9
PAINT (x + Radius + 1, y + Radius), Farbe1
PAINT (x + Radius - 1, y + Radius), Farbe1
END IF


IF tm = 1 THEN
LINE (x + Radius / 3 * 2, y + Radius / 3 * 2)-(x + Radius / 3 * 4, y + Radius / 3 * 4), Farbe2
LINE (x + Radius / 3 * 2, y + Radius / 3 * 4)-(x + Radius / 3 * 4, y + Radius / 3 * 2), Farbe2
CIRCLE (x + Radius, y + Radius), Radius / 2, Farbe2, , , .9
PAINT (x + Radius, y + Radius + 1), Farbe2
PAINT (x + Radius, y + Radius - 1), Farbe2
END IF
CASE 0: IF On.too <> 0 THEN On.too = 0: PUT (319 - Radius, 174 - Radius), Hintergrund, PSET: StoppUhr(1) = 0
END SELECT
END SUB

SUB TransaktionErfassen

wert$ = ""
lagerveraenderung$ = ""
Produkt$ = ""
Bezeichnung$ = ""

8000
CLW

Register 0, 0, 0, 0, "Neue Transaktion erstellen..."
ClearControls 3
MenuBox 2, 59, "Transaktionenrechner"

8001
Focus = ""

    LOCATE 4, 6
    PRINT "Datum ": LOCATE 4, 36: PRINT SDate$(DATE$)

    LOCATE 6, 6
    PRINT "Betrag CHF"
    wert$ = InputBox(6, 36, wert$, 10, 1)
    IF VAL(lagerveraenderung$) <> 0 THEN LOCATE 17, 50: PRINT "Stckwert: " + Franken(positiv(VAL(wert$) / VAL(lagerveraenderung$)))
    ClearControls 3
    ClearBox 2, 59, "Transaktionenrechner"
    IF Focus = "Transaktionenrechner" AND keyb = CHR$(13) THEN
        Register 8, 36, 14, 62, "Transaktionenrechner"
        a$ = "": B$ = ""
7970
        LOCATE 10, 38: PRINT "Anzahl:"
        a$ = InputBox(10, 50, a$, 10, 1)
        IF keyb = "esc" OR keyb = "up" OR keyb = "shifttab" THEN 8001
        LOCATE 12, 38: PRINT "Stckpreis:"
        B$ = InputBox(12, 50, B$, 10, 1)
        IF keyb = "up" OR keyb = "shifttab" THEN 7970
        IF keyb = "esc" THEN 8001
            wert$ = LTRIM$(STR$(VAL(a$) * VAL(B$)))
            lagerveraenderung$ = a$
    END IF
    IF VAL(wert$) <> 0 THEN
        FormatToWaehrung wert$
        TextBox 6, 36, wert$, LEN(wert$) + 1
    END IF

IF keyb = "up" OR keyb = "shifttab" THEN 8001
IF keyb = "esc" THEN 8006

8002

    LOCATE 8, 6
    PRINT "Bezeichnung"
        ERASE Combo
                Combo(1, 1) = "Verkauf extern..." '+200.--;-5p
                Combo(1, 2) = "Verkauf intern" '+200.--;-5p
                Combo(1, 3) = "Einkauf in Sortiment" '-200.--;+5p
                Combo(1, 4) = "Nachbestellung" '-200.--;+5p
                Combo(1, 5) = "Erhalt Muster/Geschenk" '+4p
                Combo(1, 6) = "Bestandeskorrektur Eigenbedarf" '-4p
                Combo(1, 7) = "Bestandeskorrektur Diebstahl" '-4p
                Combo(1, 8) = "Abschreibung..." '+/-200.--
                Combo(1, 9) = "Buchungsstorno" '+/-200.-- '+/-4p
                Combo(1, 10) = "Umtausch Ausbuchung" '-4p 'Alt: Eigenkapital Einlage
                Combo(1, 11) = "Umtausch Einbuchung" '+4p 'Alt: Eigenkapital Rcknahme
                Combo(1, 12) = "Ausserordentlicher Ertrag" '+200, +4p
                Combo(1, 13) = "Verkauf auf Kredit..." '-4p
                Combo(1, 14) = "Andere Buchung..."
        Bezeichnung$ = ComboBox(1, 8, 36, 15, 75)
        ActivItem = Bezeichnung$

IF keyb = "shifttab" THEN 8001
IF keyb = "esc" THEN 8006

IF Bezeichnung$ = "Buchungsstorno" THEN
              Dialog "Achtung: Manuelle Transaktionsstornierungen sollten nur in Ausnahmefllen, sodann aber nur mit grsster Sorgfalt gemacht werden! Manuelle Stornierungen knnen die Statistiken verflschen! OK - Besttigen, ESC - Abbrechen"
                IF keyb = "esc" OR keyb = "shifttab" THEN 8002
END IF

       IF Bezeichnung$ = "Andere Buchung..." THEN
              Register 8, 36, 12, 75, "Buchungstext:"
              Buchungstext$ = InputBox$(10, 38, Buchungstext$, 29, 1)
                IF keyb = "esc" OR keyb = "shifttab" THEN 8002
              Dialog "Achtung: Manuelle Buchungen sollten nur in Ausnahmefllen verwendet werden! OK - Besttigen, ESC - Abbrechen"
                IF keyb = "esc" OR keyb = "shifttab" THEN 8002
              Bezeichnung$ = "$" + Buchungstext$
        END IF

        IF Bezeichnung$ = "Abschreibung..." THEN
              Register 8, 36, 12, 75, "Nhere Bezeichnung zur Abschreibung:"
              abschr$ = InputBox$(10, 38, abschr$, 35, 1)
              IF keyb = "esc" OR keyb = "shifttab" THEN 8002
              Bezeichnung$ = "Abschreibung " + abschr$
        END IF

        IF Bezeichnung$ = "Verkauf extern..." THEN
5017
              Register 8, 36, 15, 75, "Verkauf extern"
                CLOSE 1
                errorlevel = 0
                OPEN "saledest.bnk" FOR INPUT AS #1
                ERASE Combo
                i% = 1
                IF errorlevel = 0 THEN
                DO WHILE NOT EOF(1)
                        LINE INPUT #1, a$
                        Combo(1, i%) = a$
                        i% = i% + 1
                LOOP
                CLOSE 1
                END IF

                Combo(1, i%) = "Neuer Verkaufspunkt..."
                letsdelete% = -1
                verkaufspunkt$ = ComboBox(1, 10, 38, 14, 73)
                letsdelete% = 0
                IF keyb = "esc" OR keyb = "shifttab" THEN 8002
                IF keyb = "delete" THEN DeleteSaleDestItem verkaufspunkt$: GOTO 5017
                IF verkaufspunkt$ = "Neuer Verkaufspunkt..." THEN
                        Register 8, 36, 15, 75, "Neuen Verkaufspunkt eintragen"
                        verkaufspunkt$ = InputBox$(10, 38, "", 21, 1)
                        IF keyb <> "esc" AND verkaufspunkt$ <> "" THEN
                            OPEN "saledest.bnk" FOR APPEND AS #1
                            PRINT #1, verkaufspunkt$
                            CLOSE #1
                        END IF
                END IF
        Bezeichnung$ = "Verkauf " + verkaufspunkt$
        END IF

8003

    LOCATE 17, 6
    PRINT "Lagervernderung"
            lagerveraenderung$ = InputBox(17, 36, lagerveraenderung$, 5, 1)
            IF VAL(lagerveraenderung$) <> 0 THEN LOCATE 17, 50: PRINT "Stckwert: " + Franken(positiv(VAL(wert$) / VAL(lagerveraenderung$)))

IF keyb = "up" OR keyb = "shifttab" THEN 8002
IF keyb = "esc" THEN 8006

        GetOKParity Bezeichnung$, wert$, lagerveraenderung$

    IF VAL(wert$) <> 0 THEN
        FormatToWaehrung wert$
    END IF
        TextBox 6, 36, wert$, LEN(wert$) + 1
        TextBox 17, 36, lagerveraenderung$, LEN(lagerveraenderung$) + 1
        IF VAL(lagerveraenderung$) = 0 THEN ActivItem = "Anderes Produkt"

8004

    LOCATE 19, 6
    PRINT "Produkt"

        ERASE Combo

            f% = FREEFILE
                i% = 0
                    DIM Produkte AS Produktedatenbank

                        OPEN "produkte.bnk" FOR RANDOM AS f% LEN = LEN(Produkte)
                            DO
                                GET f%, , Produkte
                                IF Trim$(Produkte.Produkt, CHR$(0), 1) = "" THEN EXIT DO
                                'inaktive Produkte nicht in Liste aufnehmen:
                                IF LEFT$(Produkte.Beschreibung, 1) <> "#" THEN i% = i% + 1: Combo(1, i%) = Produkte.Produkt + " (EP: " + RTRIM$(Produkte.EP) + ")"
                            LOOP UNTIL Trim$(Produkte.Produkt, CHR$(0), 1) = ""
                        CLOSE f%
                Combo(1, i% + 1) = "Anderes Produkt"
        Produkt$ = ComboBox(1, 19, 36, 23, 75)
        ActivItem = Bezeichnung$

IF keyb = "up" OR keyb = "shifttab" THEN 8003
IF keyb = "tab" THEN 8001
IF keyb = "esc" THEN EXIT SUB

IF Bezeichnung$ = "Einkauf in Sortiment" OR Bezeichnung$ = "Nachbestellung" THEN
i% = 0
OPEN "produkte.bnk" FOR RANDOM AS f% LEN = LEN(Produkte)

DO
i% = i% + 1
GET f%, i%, Produkte
IF Trim$(Produkte.Produkt, CHR$(0), 1) = "" THEN EXIT DO

IF LEFT$(Produkt$, LEN(Produkte.Produkt)) = Produkte.Produkt THEN
    IF VAL(Produkte.EP) <> positiv(VAL(wert$) / VAL(lagerveraenderung$)) THEN
        Dialog "Dieser Einkaufspreis hat sich gendert.    Alter EP: " + LTRIM$(Produkte.EP) + "    Neuer EP: " + LTRIM$(Franken(positiv(VAL(wert$) / VAL(lagerveraenderung$)))) + " Der neue Einkaufspreis wird bernommen. ESC -  Abbrechen"
        IF keyb = "esc" THEN CLOSE f%: GOTO 8001
            Produkte.EP = Franken(positiv(VAL(wert$) / VAL(lagerveraenderung$)))
            PUT f%, i%, Produkte
        EXIT DO
    END IF
END IF
LOOP UNTIL Trim$(Produkte.Produkt, CHR$(0), 1) = ""
CLOSE f%

END IF

8005

8006
IF keyb = "esc" THEN EXIT SUB

'gegebenenfalls noch fr Debitor Werte einlesen:
IF Bezeichnung$ = "Verkauf auf Kredit..." THEN
    ActivItem = "Verkauf auf Kredit"
    IF VAL(wert$) = 0 THEN Dialog "Bitte geben Sie unter 'Betrag CHF' den Verkaufsbetrag ein, den Sie von diesem Schuldner fordern wollen!": GOTO 8001

              Register 8, 36, 12, 75, "Name des Schuldners:"
              namen$ = InputBox$(10, 38, namen$, 29, 1)
                IF keyb = "esc" OR keyb = "shifttab" THEN 8002
                    PCOPY 0, 1 'Bildschirm sichern
                    Debitor$ = GetDebitor(namen$, wert$)
                    PCOPY 1, 0 'Bildschirm wiederherstellen
                IF keyb = "esc" THEN KILL Debitor$ + ".deb": GOTO 8002
                Bezeichnung$ = "Verkauf auf Kredit " + namen$

END IF



moneycab.Datum = SDate$(DATE$)
moneycab.wert = VAL(wert$)
moneycab.lagerveraenderung = VAL(lagerveraenderung$)
moneycab.Produkt = Produkt$
moneycab.Bezeichnung = Bezeichnung$


'Transaktion jetzt abspeichern:
        CLOSE #1: OPEN "moneycab.mcb" FOR APPEND AS #1
        WRITE #1, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung
        CLOSE #1

END SUB

SUB TransaktionsStorno

Register 0, 0, 0, 0, "Transaktion stornieren"

Echo ""
Echo "Bitte whlen Sie die zu stornierende Transaktion aus:"
errorlevel = 0
CLOSE
OPEN "moneycab.mcb" FOR INPUT AS 1
IF errorlevel THEN Dialog "Buchungsdatei kann nicht geffnet werden.": EXIT SUB

ERASE Combo

'Zeile aus Logbuch einlesen:
start% = 1
totalwert = 0'Variable fr die zu errechnende Totalsumme
lager = 0
DO WHILE NOT EOF(1)
        INPUT #1, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung
        Combo(1, start%) = moneycab.Datum + " " + Franken(moneycab.wert) + " (" + Produktwert(moneycab.lagerveraenderung) + ", " + moneycab.Produkt + "), " + moneycab.Bezeichnung
        start% = start% + 1
LOOP

a$ = ComboBox(1, 5, 2, 23, 79)

CLOSE 1
OPEN "moneycab.mcb" FOR INPUT AS 1
IF errorlevel THEN Dialog "Buchungsdatei kann nicht geffnet werden.": EXIT SUB
fout% = FREEFILE
OPEN "moneycab.tmp" FOR OUTPUT AS fout%

IF keyb = CHR$(13) THEN

Dialog "Die Transaktion wird storniert. ESC - Abbrechen"
    IF keyb = "esc" THEN EXIT SUB

FileCopy "moneycab.mcb", "moneycab.bak", "Sicherung der Buchungsdatei wird  durchgefhrt..."

FOR i% = 1 TO choice
        INPUT #1, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung
        IF i% < choice THEN WRITE #fout%, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung
NEXT
'Stornierungszeichen setzen ("")
moneycab.Bezeichnung = "" + moneycab.Bezeichnung
WRITE #fout%, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung

moneycab.Bezeichnung = "Buchungsstorno " + moneycab.Datum
moneycab.Datum = SDate$(DATE$)
moneycab.wert = moneycab.wert * -1
moneycab.lagerveraenderung = moneycab.lagerveraenderung * -1

'Transaktion jetzt abspeichern:
WRITE #fout%, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung

'Rest noch rckspeichern:
DO WHILE NOT EOF(1)
        INPUT #1, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung
        WRITE #fout%, moneycab.Datum, moneycab.wert, moneycab.lagerveraenderung, moneycab.Produkt, moneycab.Bezeichnung
LOOP

CLOSE 1, fout%
IF errorlevel = 0 THEN
    KILL "moneycab.mcb"
    NAME "moneycab.tmp" AS "moneycab.mcb"
    IF errorlevel = 0 THEN Dialog "Die Stornierung wurde durchgefhrt." ELSE Dialog "Ein Fehler ist bei der Stornierung aufgetreten. Wenden Sie sich an den Hersteller. Fehler-Info: moneycab.mod, sub transaktionsstorno"
ELSE
    Dialog "Ein Fehler ist aufgetreten. Versuchen Sie es nochmals, falls der Fehler erneut auftaucht, versuchen Sie, mehr freien Festplattenspeicherplatz zur Verfgung zu stellen, wenden Sie sich an den Hersteller oder nehmen Sie eine manuelle Stornierung vor."
END IF

END IF 'keyb = chr$(13)

END SUB

FUNCTION Trim$ (Variable$, Trennzeichen$, a)

mcr = 0
gef = 0
FOR i = 1 TO LEN(Variable$)
mcr = mcr + 1
a$ = MID$(Variable$, mcr)
IF LEFT$(a$, 1) = Trennzeichen$ THEN gef = gef + 1
IF gef = a - 1 THEN EXIT FOR
NEXT
IF LEFT$(a$, 1) = Trennzeichen$ THEN a$ = MID$(a$, 2) ELSE a$ = a$

mcr = 0
FOR i = 1 TO LEN(a$)
mcr = mcr + 1
IF MID$(a$, mcr, 1) = Trennzeichen$ THEN a$ = LEFT$(a$, mcr - 1): EXIT FOR
NEXT

Trim$ = a$

END FUNCTION

'setzt eine Fhrende Null hin, falls nur aus einer Ziffer besteht und wandelt die zahl in einen String um
FUNCTION zr$ (wert AS INTEGER)
    a$ = LTRIM$(STR$(wert))
    IF LEN(a$) = 1 THEN zr$ = "0" + a$ ELSE zr$ = a$
END FUNCTION

